c
c in this file leptonic tensors needed for qq -> ZZW, ZZW -> 6l
c are computed for specific helicities (h)
c
c ------------------------------------------------------------
c ------------------------------------------------------------

      subroutine WPTOZZW_kk(P,N,h,ZZW,NW)

      IMPLICIT NONE

      DOUBLE PRECISION P(0:3,2:7)
      COMPLEX*16 ZZW(0:5)
      integer lsign(2:7,8),ll,mu,nu,h,N
      integer NW ! = 0: all diagrams, = 1: no non resonant diagrams

      !possible lepton helicities
      data (lsign(ll,1),ll=2,7) / -1, -1, -1, -1, -1, -1/  !h=1
      data (lsign(ll,2),ll=2,7) / -1, -1,  1,  1, -1, -1/  !h=2
      data (lsign(ll,3),ll=2,7) /  1,  1, -1, -1, -1, -1/  !h=3
      data (lsign(ll,4),ll=2,7) /  1,  1,  1,  1, -1, -1/  !h=4

      call WPTOZZW1_kk(P,N,lsign(2,h),zzw(0),NW)

      ! helicity combi Nr. h is selected


      end

c-------------------------------------------------------------------

      SUBROUTINE WPTOZZW1_kk(P,N,lsign,zzw,NW)  
C  
C Generated by MadGraph II Version 3.0. Updated 02/19/04                
C RETURNS AMPLITUDE SQUARED SUMMED/AVG OVER COLORS
C AND HELICITIES
C FOR THE POINT IN PHASE SPACE P(0:3,NEXTERNAL)
C  
C FOR PROCESS : w+ -> e- e+ mu- mu+ vt ta+  
C  
C Crossing   1 is w+ e+ -> e+ mu- mu+ vt ta+  
C  
      IMPLICIT NONE
C  
C CONSTANTS
C  
      INTEGER    NGRAPHS 
      PARAMETER (NGRAPHS= 104) 
      INTEGER    NWAVEFUNCS
      PARAMETER (NWAVEFUNCS= 145) 
      DOUBLE PRECISION     ZERO
      PARAMETER (ZERO=0D0)
C  
C ARGUMENTS 
C  
      DOUBLE PRECISION P(0:3,2:7), Q(0:3)
      INTEGER N
      COMPLEX*16 zzw(0:5)
      INTEGER lsign(2:7)
      integer NW ! = 0: all diagrams, = 1: no non resonant diagrams
C  
C LOCAL VARIABLES 
C  
      INTEGER I,J, mu
      COMPLEX*16 AMP(NGRAPHS)
      COMPLEX*16 W(6,NWAVEFUNCS)
c  lepton spinors and polarization vectors
#include "tensor.inc"

      logical lswitch
      parameter (lswitch=.true.)
C  
C GLOBAL VARIABLES
C  
#include "VBFNLO/utilities/coupl.inc"
#include "VBFNLO/utilities/kkcoupl.inc"
      COMPLEX*16 KK1(6,1:kkw),AMPK1(1:kkw), KK2(6,1:kkw),AMPK2(1:kkw)
	COMPLEX*16 kkh1(6,1:kkh), AMPKH(1:kkh)
	COMPLEX*16 h1(6), AMPH
      INTEGER k

C ----------
C BEGIN CODE
C ----------

      if (lswitch) then
         do i=1,6
            w(i,2)  = zem(i,N) !
            w(i,3)  = zep(i,N) !Z1 boson
            w(i,4)  = zmm(i,N) !
            w(i,5)  = zmp(i,N) !Z2 boson
            w(i,6)  = ztm(i,N) !
            w(i,7)  = ztp(i,N) ! W+ boson

            w(i,8)  = ae(i,N)
            w(i,12) = ze(i,N)
            w(i,40) = zmu(i,N)
            w(i,38) = amu(i,N)
            w(i,145) = wbos(i,N)
         enddo
      endif

      do mu = 0,3
         q(mu) = p(mu,2)+p(mu,3)+p(mu,4)+p(mu,5)+p(mu,6)+p(mu,7)
      enddo

      if (.not.lswitch) then        
         CALL OXXXXX(P(0,2), ZERO , lsign(2),+1,W(1,2   ))        
         CALL IXXXXX(P(0,3), ZERO ,-lsign(3),-1,W(1,3   ))        
         CALL OXXXXX(P(0,4), ZERO , lsign(4),+1,W(1,4   ))        
         CALL IXXXXX(P(0,5), ZERO ,-lsign(5),-1,W(1,5   ))        
         CALL OXXXXX(P(0,6), ZERO , lsign(6),+1,W(1,6   ))       
         CALL IXXXXX(P(0,7), ZERO ,-lsign(7),-1,W(1,7   ))
         CALL JIOXXX(W(1,3   ),W(1,2   ),GAL ,ZERO    ,ZERO    ,W(1,8))
         CALL JIOXXX(W(1,3   ),W(1,2   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,12))
         CALL JIOXXX(W(1,7   ),W(1,6   ),GWF ,WMASS   ,WWIDTH  ,W(1,24))
         CALL JIOXXX(W(1,5   ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,34))
         CALL JIOXXX(W(1,5   ),W(1,4   ),GAL ,ZERO    ,ZERO    ,W(1,36)) 
      endif 

      do mu = 0,3
      call TRIBOSVCARTX(Q(0), WMASS, WWIDTH, MU, -1, W(1,1))
c      CALL JIOXXX(W(1,3   ),W(1,2   ),GAL ,ZERO    ,AWIDTH  ,W(1,8   ))    ! A1 -> e+ e-
      CALL FVOXXX(W(1,4   ),W(1,8   ),GAL ,ZERO    ,ZERO    ,W(1,9   ))    
      CALL JIOXXX(W(1,5   ),W(1,9   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,10  ))    
      CALL FVIXXX(W(1,7   ),W(1,1   ),GWF ,ZERO    ,ZERO    ,W(1,11  ))    
      CALL IOVXXX(W(1,11  ),W(1,6   ),W(1,10  ),GZN ,AMP(1   ))            
c      CALL JIOXXX(W(1,3   ),W(1,2   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,12  ))    ! Z1 -> e+ e-
      CALL FVOXXX(W(1,4   ),W(1,12  ),GZL ,ZERO    ,ZERO    ,W(1,13  ))    
      CALL JIOXXX(W(1,5   ),W(1,13  ),GZL ,ZMASS   ,ZWIDTH  ,W(1,14  ))    
      CALL IOVXXX(W(1,11  ),W(1,6   ),W(1,14  ),GZN ,AMP(2   ))            
      CALL JIOXXX(W(1,5   ),W(1,9   ),GAL ,ZERO    ,AWIDTH  ,W(1,15  ))    
      CALL JVVXXX(W(1,15  ),W(1,1   ),GWWA ,WMASS   ,WWIDTH  ,W(1,         
     &     16  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,16  ),GWF ,AMP(3   ))            
      CALL JVVXXX(W(1,10  ),W(1,1   ),GWWZ ,WMASS   ,WWIDTH  ,W(1,         
     &     17  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,17  ),GWF ,AMP(4   ))            
      CALL JIOXXX(W(1,5   ),W(1,13  ),GAL ,ZERO    ,AWIDTH  ,W(1,18  ))    
      CALL JVVXXX(W(1,18  ),W(1,1   ),GWWA ,WMASS   ,WWIDTH  ,W(1,         
     &     19  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,19  ),GWF ,AMP(5   ))            
      CALL JVVXXX(W(1,14  ),W(1,1   ),GWWZ ,WMASS   ,WWIDTH  ,W(1,         
     &     20  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,20  ),GWF ,AMP(6   ))            
      CALL FVIXXX(W(1,7   ),W(1,15  ),GAL ,LMASS   ,ZERO    ,W(1,21  ))    
      CALL IOVXXX(W(1,21  ),W(1,6   ),W(1,1   ),GWF ,AMP(7   ))            
      CALL FVIXXX(W(1,7   ),W(1,10  ),GZL ,LMASS   ,ZERO    ,W(1,22  ))    
      CALL IOVXXX(W(1,22  ),W(1,6   ),W(1,1   ),GWF ,AMP(8   ))            
      CALL FVIXXX(W(1,7   ),W(1,18  ),GAL ,LMASS   ,ZERO    ,W(1,23  ))    
      CALL IOVXXX(W(1,23  ),W(1,6   ),W(1,1   ),GWF ,AMP(9   ))            
      CALL FVIXXX(W(1,7   ),W(1,14  ),GZL ,LMASS   ,ZERO    ,W(1,24  ))    
      CALL IOVXXX(W(1,24  ),W(1,6   ),W(1,1   ),GWF ,AMP(10  ))            
      CALL FVIXXX(W(1,5   ),W(1,1   ),GWF ,ZERO    ,ZERO    ,W(1,25  ))    
      CALL JIOXXX(W(1,25  ),W(1,4   ),GWF ,WMASS   ,WWIDTH  ,W(1,26  ))    
      CALL FVIXXX(W(1,3   ),W(1,26  ),GWF ,ZERO    ,ZERO    ,W(1,27  ))    
      CALL JIOXXX(W(1,27  ),W(1,2   ),GWF ,WMASS   ,WWIDTH  ,W(1,28  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,28  ),GWF ,AMP(11  ))            
      CALL FVIXXX(W(1,25  ),W(1,12  ),GZN ,ZERO    ,ZERO    ,W(1,29  ))    
      CALL JIOXXX(W(1,29  ),W(1,4   ),GWF ,WMASS   ,WWIDTH  ,W(1,30  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,30  ),GWF ,AMP(12  ))            
      CALL JVVXXX(W(1,8   ),W(1,26  ),GWWA ,WMASS   ,WWIDTH  ,W(1,         
     &     31  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,31  ),GWF ,AMP(13  ))            
      CALL JVVXXX(W(1,12  ),W(1,26  ),GWWZ ,WMASS   ,WWIDTH  ,W(1,         
     &     32  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,32  ),GWF ,AMP(14  ))            
      CALL FVIXXX(W(1,7   ),W(1,8   ),GAL ,LMASS   ,ZERO    ,W(1,33  ))    
      CALL IOVXXX(W(1,33  ),W(1,6   ),W(1,26  ),GWF ,AMP(15  ))            
      CALL FVIXXX(W(1,7   ),W(1,12  ),GZL ,LMASS   ,ZERO    ,W(1,34  ))    
      CALL IOVXXX(W(1,34  ),W(1,6   ),W(1,26  ),GWF ,AMP(16  ))            
      CALL FVIXXX(W(1,7   ),W(1,26  ),GWF ,ZERO    ,ZERO    ,W(1,35  ))    
      CALL IOVXXX(W(1,35  ),W(1,6   ),W(1,12  ),GZN ,AMP(17  ))            
      CALL JIOXXX(W(1,25  ),W(1,9   ),GWF ,WMASS   ,WWIDTH  ,W(1,36  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,36  ),GWF ,AMP(18  ))            
      CALL JIOXXX(W(1,25  ),W(1,13  ),GWF ,WMASS   ,WWIDTH  ,W(1,37  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,37  ),GWF ,AMP(19  ))            
c      CALL JIOXXX(W(1,5   ),W(1,4   ),GAL ,ZERO    ,AWIDTH  ,W(1,38  )) ! A2 -> mp mm   
      CALL FVIXXX(W(1,33  ),W(1,38  ),GAL ,LMASS   ,ZERO    ,W(1,39  ))    
      CALL IOVXXX(W(1,39  ),W(1,6   ),W(1,1   ),GWF ,AMP(20  ))            
c      CALL JIOXXX(W(1,5   ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,40  )) ! Z2 -> mp mm   
      CALL FVIXXX(W(1,33  ),W(1,40  ),GZL ,LMASS   ,ZERO    ,W(1,41  ))    
      CALL IOVXXX(W(1,41  ),W(1,6   ),W(1,1   ),GWF ,AMP(21  ))            
      CALL FVIXXX(W(1,34  ),W(1,38  ),GAL ,LMASS   ,ZERO    ,W(1,42  ))    
      CALL IOVXXX(W(1,42  ),W(1,6   ),W(1,1   ),GWF ,AMP(22  ))            
      CALL FVIXXX(W(1,34  ),W(1,40  ),GZL ,LMASS   ,ZERO    ,W(1,43  ))    
      CALL IOVXXX(W(1,43  ),W(1,6   ),W(1,1   ),GWF ,AMP(23  ))            
      CALL FVIXXX(W(1,7   ),W(1,38  ),GAL ,LMASS   ,ZERO    ,W(1,44  ))    
      CALL FVIXXX(W(1,44  ),W(1,8   ),GAL ,LMASS   ,ZERO    ,W(1,45  ))    
      CALL IOVXXX(W(1,45  ),W(1,6   ),W(1,1   ),GWF ,AMP(24  ))            
      CALL FVIXXX(W(1,7   ),W(1,40  ),GZL ,LMASS   ,ZERO    ,W(1,46  ))    
      CALL FVIXXX(W(1,46  ),W(1,8   ),GAL ,LMASS   ,ZERO    ,W(1,47  ))    
      CALL IOVXXX(W(1,47  ),W(1,6   ),W(1,1   ),GWF ,AMP(25  ))            
      CALL FVIXXX(W(1,44  ),W(1,12  ),GZL ,LMASS   ,ZERO    ,W(1,48  ))    
      CALL IOVXXX(W(1,48  ),W(1,6   ),W(1,1   ),GWF ,AMP(26  ))            
      CALL FVIXXX(W(1,46  ),W(1,12  ),GZL ,LMASS   ,ZERO    ,W(1,49  ))    
      CALL IOVXXX(W(1,49  ),W(1,6   ),W(1,1   ),GWF ,AMP(27  ))            
      CALL JVVXXX(W(1,38  ),W(1,1   ),GWWA ,WMASS   ,WWIDTH  ,W(1,         
     &     50  ))                                                          
      CALL FVIXXX(W(1,3   ),W(1,50  ),GWF ,ZERO    ,ZERO    ,W(1,51  ))    
      CALL JIOXXX(W(1,51  ),W(1,2   ),GWF ,WMASS   ,WWIDTH  ,W(1,52  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,52  ),GWF ,AMP(28  ))            
      CALL JVVXXX(W(1,40  ),W(1,1   ),GWWZ ,WMASS   ,WWIDTH  ,W(1,         
     &     53  ))                                                          
      CALL FVIXXX(W(1,3   ),W(1,53  ),GWF ,ZERO    ,ZERO    ,W(1,54  ))    
      CALL JIOXXX(W(1,54  ),W(1,2   ),GWF ,WMASS   ,WWIDTH  ,W(1,55  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,55  ),GWF ,AMP(29  ))            
      CALL JVVXXX(W(1,8   ),W(1,1   ),GWWA ,WMASS   ,WWIDTH  ,W(1,         
     &     56  ))                                                          
      CALL FVIXXX(W(1,5   ),W(1,56  ),GWF ,ZERO    ,ZERO    ,W(1,57  ))    
      CALL JIOXXX(W(1,57  ),W(1,4   ),GWF ,WMASS   ,WWIDTH  ,W(1,58  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,58  ),GWF ,AMP(30  ))            
      CALL JVVXXX(W(1,12  ),W(1,1   ),GWWZ ,WMASS   ,WWIDTH  ,W(1,         
     &     59  ))                                                          
      CALL FVIXXX(W(1,5   ),W(1,59  ),GWF ,ZERO    ,ZERO    ,W(1,60  ))    
      CALL JIOXXX(W(1,60  ),W(1,4   ),GWF ,WMASS   ,WWIDTH  ,W(1,61  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,61  ),GWF ,AMP(31  ))            
		        
	CALL W3W3XX(w(1,1), w(1,38), w(1,145), w(1,8), 1.d0,
     & GWWAA_k(0,0,0,0), amp(32)) 
	CALL W3W3XX(w(1,1), w(1,40), w(1,145), w(1,8), 1.d0,
     & GWWAZ_k(0,0,0,0), amp(33))
	CALL W3W3XX(w(1,1), w(1,38), w(1,145), w(1,12), 1.d0,
     & GWWAZ_k(0,0,0,0), amp(34))
	CALL W3W3XX(w(1,1), w(1,40), w(1,145), w(1,12), 1.d0,
     & GWWZZ_k(0,0,0,0), amp(35))

      CALL FVIXXX(W(1,11  ),W(1,40  ),GZN ,ZERO    ,ZERO    ,W(1,66  ))    
      CALL IOVXXX(W(1,66  ),W(1,6   ),W(1,12  ),GZN ,AMP(36  ))            
      CALL JVVXXX(W(1,8   ),W(1,50  ),GWWA ,WMASS   ,WWIDTH  ,W(1,         
     &     67  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,67  ),GWF ,AMP(37  ))            
      CALL JVVXXX(W(1,8   ),W(1,53  ),GWWA ,WMASS   ,WWIDTH  ,W(1,         
     &     68  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,68  ),GWF ,AMP(38  ))            
      CALL JVVXXX(W(1,12  ),W(1,50  ),GWWZ ,WMASS   ,WWIDTH  ,W(1,         
     &     69  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,69  ),GWF ,AMP(39  ))            
      CALL JVVXXX(W(1,12  ),W(1,53  ),GWWZ ,WMASS   ,WWIDTH  ,W(1,         
     &     70  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,70  ),GWF ,AMP(40  ))            
      CALL IOVXXX(W(1,33  ),W(1,6   ),W(1,50  ),GWF ,AMP(41  ))            
      CALL IOVXXX(W(1,33  ),W(1,6   ),W(1,53  ),GWF ,AMP(42  ))            
      CALL IOVXXX(W(1,34  ),W(1,6   ),W(1,50  ),GWF ,AMP(43  ))            
      CALL IOVXXX(W(1,34  ),W(1,6   ),W(1,53  ),GWF ,AMP(44  ))            
      CALL FVIXXX(W(1,44  ),W(1,1   ),GWF ,ZERO    ,ZERO    ,W(1,71  ))    
      CALL IOVXXX(W(1,71  ),W(1,6   ),W(1,12  ),GZN ,AMP(45  ))            
      CALL FVIXXX(W(1,46  ),W(1,1   ),GWF ,ZERO    ,ZERO    ,W(1,72  ))    
      CALL IOVXXX(W(1,72  ),W(1,6   ),W(1,12  ),GZN ,AMP(46  ))            
      CALL FVIXXX(W(1,7   ),W(1,50  ),GWF ,ZERO    ,ZERO    ,W(1,73  ))    
      CALL IOVXXX(W(1,73  ),W(1,6   ),W(1,12  ),GZN ,AMP(47  ))            
      CALL FVIXXX(W(1,7   ),W(1,53  ),GWF ,ZERO    ,ZERO    ,W(1,74  ))    
      CALL IOVXXX(W(1,74  ),W(1,6   ),W(1,12  ),GZN ,AMP(48  ))            
      CALL FVIXXX(W(1,11  ),W(1,12  ),GZN ,ZERO    ,ZERO    ,W(1,75  ))    
      CALL IOVXXX(W(1,75  ),W(1,6   ),W(1,40  ),GZN ,AMP(49  ))            
      CALL JVVXXX(W(1,38  ),W(1,56  ),GWWA ,WMASS   ,WWIDTH  ,W(1,         
     &     76  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,76  ),GWF ,AMP(50  ))            
      CALL JVVXXX(W(1,40  ),W(1,56  ),GWWZ ,WMASS   ,WWIDTH  ,W(1,         
     &     77  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,77  ),GWF ,AMP(51  ))            
      CALL JVVXXX(W(1,38  ),W(1,59  ),GWWA ,WMASS   ,WWIDTH  ,W(1,         
     &     78  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,78  ),GWF ,AMP(52  ))            
      CALL JVVXXX(W(1,40  ),W(1,59  ),GWWZ ,WMASS   ,WWIDTH  ,W(1,         
     &     79  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,79  ),GWF ,AMP(53  ))            
      CALL FVIXXX(W(1,33  ),W(1,1   ),GWF ,ZERO    ,ZERO    ,W(1,80  ))    
      CALL IOVXXX(W(1,80  ),W(1,6   ),W(1,40  ),GZN ,AMP(54  ))            
      CALL FVIXXX(W(1,34  ),W(1,1   ),GWF ,ZERO    ,ZERO    ,W(1,81  ))    
      CALL IOVXXX(W(1,81  ),W(1,6   ),W(1,40  ),GZN ,AMP(55  ))            
      CALL FVIXXX(W(1,7   ),W(1,56  ),GWF ,ZERO    ,ZERO    ,W(1,82  ))    
      CALL IOVXXX(W(1,82  ),W(1,6   ),W(1,40  ),GZN ,AMP(56  ))            
      CALL FVIXXX(W(1,7   ),W(1,59  ),GWF ,ZERO    ,ZERO    ,W(1,83  ))    
      CALL IOVXXX(W(1,83  ),W(1,6   ),W(1,40  ),GZN ,AMP(57  ))            
      CALL IOVXXX(W(1,44  ),W(1,6   ),W(1,56  ),GWF ,AMP(58  ))            
      CALL IOVXXX(W(1,46  ),W(1,6   ),W(1,56  ),GWF ,AMP(59  ))            
      CALL IOVXXX(W(1,44  ),W(1,6   ),W(1,59  ),GWF ,AMP(60  ))            
      CALL IOVXXX(W(1,46  ),W(1,6   ),W(1,59  ),GWF ,AMP(61  ))            
      CALL FVIXXX(W(1,5   ),W(1,8   ),GAL ,ZERO    ,ZERO    ,W(1,84  ))    
      CALL JIOXXX(W(1,84  ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,85  ))    
      CALL IOVXXX(W(1,11  ),W(1,6   ),W(1,85  ),GZN ,AMP(62  ))            
      CALL FVIXXX(W(1,5   ),W(1,12  ),GZL ,ZERO    ,ZERO    ,W(1,86  ))    
      CALL JIOXXX(W(1,86  ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,87  ))    
      CALL IOVXXX(W(1,11  ),W(1,6   ),W(1,87  ),GZN ,AMP(63  ))            
      CALL JIOXXX(W(1,84  ),W(1,4   ),GAL ,ZERO    ,AWIDTH  ,W(1,88  ))    
      CALL JVVXXX(W(1,88  ),W(1,1   ),GWWA ,WMASS   ,WWIDTH  ,W(1,         
     &     89  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,89  ),GWF ,AMP(64  ))            
      CALL JVVXXX(W(1,85  ),W(1,1   ),GWWZ ,WMASS   ,WWIDTH  ,W(1,         
     &     90  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,90  ),GWF ,AMP(65  ))            
      CALL JIOXXX(W(1,86  ),W(1,4   ),GAL ,ZERO    ,AWIDTH  ,W(1,91  ))    
      CALL JVVXXX(W(1,91  ),W(1,1   ),GWWA ,WMASS   ,WWIDTH  ,W(1,         
     &     92  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,92  ),GWF ,AMP(66  ))            
      CALL JVVXXX(W(1,87  ),W(1,1   ),GWWZ ,WMASS   ,WWIDTH  ,W(1,         
     &     93  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,93  ),GWF ,AMP(67  ))            
      CALL FVIXXX(W(1,7   ),W(1,88  ),GAL ,LMASS   ,ZERO    ,W(1,94  ))    
      CALL IOVXXX(W(1,94  ),W(1,6   ),W(1,1   ),GWF ,AMP(68  ))            
      CALL FVIXXX(W(1,7   ),W(1,85  ),GZL ,LMASS   ,ZERO    ,W(1,95  ))    
      CALL IOVXXX(W(1,95  ),W(1,6   ),W(1,1   ),GWF ,AMP(69  ))            
      CALL FVIXXX(W(1,7   ),W(1,91  ),GAL ,LMASS   ,ZERO    ,W(1,96  ))    
      CALL IOVXXX(W(1,96  ),W(1,6   ),W(1,1   ),GWF ,AMP(70  ))            
      CALL FVIXXX(W(1,7   ),W(1,87  ),GZL ,LMASS   ,ZERO    ,W(1,97  ))    
      CALL IOVXXX(W(1,97  ),W(1,6   ),W(1,1   ),GWF ,AMP(71  ))            
      CALL FVIXXX(W(1,84  ),W(1,1   ),GWF ,ZERO    ,ZERO    ,W(1,98  ))    
      CALL JIOXXX(W(1,98  ),W(1,4   ),GWF ,WMASS   ,WWIDTH  ,W(1,99  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,99  ),GWF ,AMP(72  ))            
      CALL FVIXXX(W(1,86  ),W(1,1   ),GWF ,ZERO    ,ZERO    ,W(1,100 ))    
      CALL JIOXXX(W(1,100 ),W(1,4   ),GWF ,WMASS   ,WWIDTH  ,W(1,101 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,101 ),GWF ,AMP(73  ))            
      CALL FVOXXX(W(1,2   ),W(1,38  ),GAL ,ZERO    ,ZERO    ,W(1,102 ))    
      CALL JIOXXX(W(1,3   ),W(1,102 ),GZL ,ZMASS   ,ZWIDTH  ,W(1,103 ))    
      CALL IOVXXX(W(1,11  ),W(1,6   ),W(1,103 ),GZN ,AMP(74  ))            
      CALL FVOXXX(W(1,2   ),W(1,40  ),GZL ,ZERO    ,ZERO    ,W(1,104 ))    
      CALL JIOXXX(W(1,3   ),W(1,104 ),GZL ,ZMASS   ,ZWIDTH  ,W(1,105 ))    
      CALL IOVXXX(W(1,11  ),W(1,6   ),W(1,105 ),GZN ,AMP(75  ))            
      CALL JIOXXX(W(1,3   ),W(1,102 ),GAL ,ZERO    ,AWIDTH  ,W(1,106 ))    
      CALL JVVXXX(W(1,106 ),W(1,1   ),GWWA ,WMASS   ,WWIDTH  ,W(1,         
     &     107 ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,107 ),GWF ,AMP(76  ))            
      CALL JVVXXX(W(1,103 ),W(1,1   ),GWWZ ,WMASS   ,WWIDTH  ,W(1,         
     &     108 ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,108 ),GWF ,AMP(77  ))            
      CALL JIOXXX(W(1,3   ),W(1,104 ),GAL ,ZERO    ,AWIDTH  ,W(1,109 ))    
      CALL JVVXXX(W(1,109 ),W(1,1   ),GWWA ,WMASS   ,WWIDTH  ,W(1,         
     &     110 ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,110 ),GWF ,AMP(78  ))            
      CALL JVVXXX(W(1,105 ),W(1,1   ),GWWZ ,WMASS   ,WWIDTH  ,W(1,         
     &     111 ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,111 ),GWF ,AMP(79  ))            
      CALL FVIXXX(W(1,7   ),W(1,106 ),GAL ,LMASS   ,ZERO    ,W(1,112 ))    
      CALL IOVXXX(W(1,112 ),W(1,6   ),W(1,1   ),GWF ,AMP(80  ))            
      CALL FVIXXX(W(1,7   ),W(1,103 ),GZL ,LMASS   ,ZERO    ,W(1,113 ))    
      CALL IOVXXX(W(1,113 ),W(1,6   ),W(1,1   ),GWF ,AMP(81  ))            
      CALL FVIXXX(W(1,7   ),W(1,109 ),GAL ,LMASS   ,ZERO    ,W(1,114 ))    
      CALL IOVXXX(W(1,114 ),W(1,6   ),W(1,1   ),GWF ,AMP(82  ))            
      CALL FVIXXX(W(1,7   ),W(1,105 ),GZL ,LMASS   ,ZERO    ,W(1,115 ))    
      CALL IOVXXX(W(1,115 ),W(1,6   ),W(1,1   ),GWF ,AMP(83  ))            
      CALL FVIXXX(W(1,3   ),W(1,1   ),GWF ,ZERO    ,ZERO    ,W(1,116 ))    
      CALL FVIXXX(W(1,116 ),W(1,40  ),GZN ,ZERO    ,ZERO    ,W(1,117 ))    
      CALL JIOXXX(W(1,117 ),W(1,2   ),GWF ,WMASS   ,WWIDTH  ,W(1,118 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,118 ),GWF ,AMP(84  ))            
      CALL JIOXXX(W(1,116 ),W(1,2   ),GWF ,WMASS   ,WWIDTH  ,W(1,119 ))    
      CALL FVIXXX(W(1,5   ),W(1,119 ),GWF ,ZERO    ,ZERO    ,W(1,120 ))    
      CALL JIOXXX(W(1,120 ),W(1,4   ),GWF ,WMASS   ,WWIDTH  ,W(1,121 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,121 ),GWF ,AMP(85  ))            
      CALL JIOXXX(W(1,116 ),W(1,102 ),GWF ,WMASS   ,WWIDTH  ,W(1,122 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,122 ),GWF ,AMP(86  ))            
      CALL JIOXXX(W(1,116 ),W(1,104 ),GWF ,WMASS   ,WWIDTH  ,W(1,123 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,123 ),GWF ,AMP(87  ))            
      CALL JVVXXX(W(1,38  ),W(1,119 ),GWWA ,WMASS   ,WWIDTH  ,W(1,         
     &     124 ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,124 ),GWF ,AMP(88  ))            
      CALL JVVXXX(W(1,40  ),W(1,119 ),GWWZ ,WMASS   ,WWIDTH  ,W(1,         
     &     125 ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,125 ),GWF ,AMP(89  ))            
      CALL FVIXXX(W(1,7   ),W(1,119 ),GWF ,ZERO    ,ZERO    ,W(1,126 ))    
      CALL IOVXXX(W(1,126 ),W(1,6   ),W(1,40  ),GZN ,AMP(90  ))            
      CALL IOVXXX(W(1,44  ),W(1,6   ),W(1,119 ),GWF ,AMP(91  ))            
      CALL IOVXXX(W(1,46  ),W(1,6   ),W(1,119 ),GWF ,AMP(92  ))            
      CALL FVIXXX(W(1,3   ),W(1,38  ),GAL ,ZERO    ,ZERO    ,W(1,127 ))    
      CALL JIOXXX(W(1,127 ),W(1,2   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,128 ))    
      CALL IOVXXX(W(1,11  ),W(1,6   ),W(1,128 ),GZN ,AMP(93  ))            
      CALL FVIXXX(W(1,3   ),W(1,40  ),GZL ,ZERO    ,ZERO    ,W(1,129 ))    
      CALL JIOXXX(W(1,129 ),W(1,2   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,130 ))    
      CALL IOVXXX(W(1,11  ),W(1,6   ),W(1,130 ),GZN ,AMP(94  ))            
      CALL JIOXXX(W(1,127 ),W(1,2   ),GAL ,ZERO    ,AWIDTH  ,W(1,131 ))    
      CALL JVVXXX(W(1,131 ),W(1,1   ),GWWA ,WMASS   ,WWIDTH  ,W(1,         
     &     132 ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,132 ),GWF ,AMP(95  ))            
      CALL JVVXXX(W(1,128 ),W(1,1   ),GWWZ ,WMASS   ,WWIDTH  ,W(1,         
     &     133 ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,133 ),GWF ,AMP(96  ))            
      CALL JIOXXX(W(1,129 ),W(1,2   ),GAL ,ZERO    ,AWIDTH  ,W(1,134 ))    
      CALL JVVXXX(W(1,134 ),W(1,1   ),GWWA ,WMASS   ,WWIDTH  ,W(1,         
     &     135 ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,135 ),GWF ,AMP(97  ))            
      CALL JVVXXX(W(1,130 ),W(1,1   ),GWWZ ,WMASS   ,WWIDTH  ,W(1,         
     &     136 ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,136 ),GWF ,AMP(98  ))            
      CALL FVIXXX(W(1,7   ),W(1,131 ),GAL ,LMASS   ,ZERO    ,W(1,137 ))    
      CALL IOVXXX(W(1,137 ),W(1,6   ),W(1,1   ),GWF ,AMP(99  ))            
      CALL FVIXXX(W(1,7   ),W(1,128 ),GZL ,LMASS   ,ZERO    ,W(1,138 ))    
      CALL IOVXXX(W(1,138 ),W(1,6   ),W(1,1   ),GWF ,AMP(100 ))            
      CALL FVIXXX(W(1,7   ),W(1,134 ),GAL ,LMASS   ,ZERO    ,W(1,139 ))    
      CALL IOVXXX(W(1,139 ),W(1,6   ),W(1,1   ),GWF ,AMP(101 ))            
      CALL FVIXXX(W(1,7   ),W(1,130 ),GZL ,LMASS   ,ZERO    ,W(1,140 ))    
      CALL IOVXXX(W(1,140 ),W(1,6   ),W(1,1   ),GWF ,AMP(102 ))            
      CALL FVIXXX(W(1,127 ),W(1,1   ),GWF ,ZERO    ,ZERO    ,W(1,141 ))    
      CALL JIOXXX(W(1,141 ),W(1,2   ),GWF ,WMASS   ,WWIDTH  ,W(1,142 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,142 ),GWF ,AMP(103 ))            
      CALL FVIXXX(W(1,129 ),W(1,1   ),GWF ,ZERO    ,ZERO    ,W(1,143 ))    
      CALL JIOXXX(W(1,143 ),W(1,2   ),GWF ,WMASS   ,WWIDTH  ,W(1,144 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,144 ),GWF ,AMP(104 ))
c kk graph
	do k=1,kkhw
	Call JVVXXX(w(1,40),w(1,1),gwwz_k(k,0,0),w1mass_k(k),w1width_k(k), KK1(1,k)) ! like graph 40
	Call VVVXXX(kk1(1,k),w(1,145),w(1,12),gwwz_k(k,0,0), ampk1(k))

	Call JVVXXX(w(1,12),w(1,1),gwwz_k(k,0,0),w1mass_k(k),w1width_k(k), KK2(1,k)) ! like graph 53
	Call VVVXXX(kk2(1,k),w(1,145),w(1,40),gwwz_k(k,0,0), ampk2(k))
	enddo
	
cc higgs graphs
      if(hswitchzzw) then
c SM higgs graph
	CALL HVVXXX(W(1,40), W(1,12), gzzh, hmass, hwidth, h1(1))
	CALL VVSXXX(W(1,1), W(1,145),h1(1), gwwh, AMPH)
c KK higgs graph
      do k=1,kkhh
	CALL HVVXXX(W(1,40), W(1,12), gzzh_k(0,0,k), h1mass_k(k), 
     &	h1width_k(k), kkh1(1,k))
	CALL VVSXXX(W(1,1), W(1,145),kkh1(1,k), gwwh_k(0,0,k), AMPKH(k))
      enddo
      endif
	
      zzw(mu) = -AMP(   1)-AMP(   2)-AMP(   3)-AMP(   4)-AMP(   5)
     &             -AMP(   6)-AMP(   7)-AMP(   8)-AMP(   9)-AMP(  10)
     &             -AMP(  11)-AMP(  12)-AMP(  13)-AMP(  14)-AMP(  15)
     &             -AMP(  16)-AMP(  17)-AMP(  18)-AMP(  19)-AMP(  20)
     &             -AMP(  21)-AMP(  22)-AMP(  23)-AMP(  24)-AMP(  25)
     &             -AMP(  26)-AMP(  27)-AMP(  28)-AMP(  29)-AMP(  30)
     &             -AMP(  31)-AMP(  32)-AMP(  33)-AMP(  34)-AMP(  35)
     &             -AMP(  36)-AMP(  37)-AMP(  38)-AMP(  39)-AMP(  40)
     &             -AMP(  41)-AMP(  42)-AMP(  43)-AMP(  44)-AMP(  45)
     &             -AMP(  46)-AMP(  47)-AMP(  48)-AMP(  49)-AMP(  50)
     &             -AMP(  51)-AMP(  52)-AMP(  53)-AMP(  54)-AMP(  55)
     &             -AMP(  56)-AMP(  57)-AMP(  58)-AMP(  59)-AMP(  60)
     &             -AMP(  61)-AMP(  62)-AMP(  63)-AMP(  64)-AMP(  65)
     &             -AMP(  66)-AMP(  67)-AMP(  68)-AMP(  69)-AMP(  70)
     &             -AMP(  71)-AMP(  72)-AMP(  73)-AMP(  74)-AMP(  75)
     &             -AMP(  76)-AMP(  77)-AMP(  78)-AMP(  79)-AMP(  80)
     &             -AMP(  81)-AMP(  82)-AMP(  83)-AMP(  84)-AMP(  85)
     &             -AMP(  86)-AMP(  87)-AMP(  88)-AMP(  89)-AMP(  90)
     &             -AMP(  91)-AMP(  92)-AMP(  93)-AMP(  94)-AMP(  95)
     &             -AMP(  96)-AMP(  97)-AMP(  98)-AMP(  99)-AMP( 100)
     &             -AMP( 101)-AMP( 102)-AMP( 103)-AMP( 104)

      do k=1,kkhw
      zzw(mu)=zzw(mu)-AMPK1(k)-AMPK2(k)
      enddo

	if (hswitchzzw) then
	zzw(mu)= zzw(mu)-AMPH
	do k=1, kkhh
	zzw(mu)=zzw(mu)-AMPKH(k)
	enddo
	endif

      enddo
      zzw(4) = dcmplx(q(0),q(3))
      zzw(5) = dcmplx(q(1),q(2))

      END

c ----------------------------------------------------------------------

      subroutine WMTOZZW_kk(P,N,h,ZZW,NW)

      IMPLICIT NONE

      DOUBLE PRECISION P(0:3,2:7)
      COMPLEX*16 ZZW(0:5)
      integer lsign(2:7,8),ll,mu,nu,h,N
      integer NW ! = 0: all diagrams, = 1: no non resonant diagrams

      !possible lepton helicities
      data (lsign(ll,1),ll=2,7) / -1, -1, -1, -1, -1, -1/  !h=1
      data (lsign(ll,2),ll=2,7) / -1, -1,  1,  1, -1, -1/  !h=2
      data (lsign(ll,3),ll=2,7) /  1,  1, -1, -1, -1, -1/  !h=3
      data (lsign(ll,4),ll=2,7) /  1,  1,  1,  1, -1, -1/  !h=4

      call WMTOZZW1_kk(P,N,lsign(2,h),zzw(0),NW)

      ! helicity combi Nr. h is selected

      end

c-------------------------------------------------------------------

      SUBROUTINE WMTOZZW1_kk(P,N,lsign,zzw,NW)  
C  
C Generated by MadGraph II Version 3.0. Updated 02/19/04                
C RETURNS AMPLITUDE SQUARED SUMMED/AVG OVER COLORS
C FOR THE POINT WITH EXTERNAL LINES W(0:6,NEXTERNAL)
C  
C FOR PROCESS : w- -> e- e+ mu- mu+ ta- vt~  
C
      IMPLICIT NONE
C  
C CONSTANTS
C  
      INTEGER    NGRAPHS 
      PARAMETER (NGRAPHS= 104) 
      INTEGER    NWAVEFUNCS
      PARAMETER (NWAVEFUNCS= 129) 
      DOUBLE PRECISION     ZERO
      PARAMETER (ZERO=0D0)
C  
C ARGUMENTS 
C  
      DOUBLE PRECISION P(0:3,2:7), Q(0:3)
      INTEGER N
      COMPLEX*16 zzw(0:5)
      INTEGER lsign(2:7)
      integer NW ! = 0: all diagrams, = 1: no non resonant diagrams
C  
C LOCAL VARIABLES 
C  
      INTEGER I,J, mu
      COMPLEX*16 AMP(NGRAPHS)
      COMPLEX*16 W(6,NWAVEFUNCS)
c  lepton spinors and polarization vectors
#include "tensor.inc"

      logical lswitch
      parameter (lswitch=.true.)
C  
C GLOBAL VARIABLES
C  
#include "VBFNLO/utilities/coupl.inc"
#include "VBFNLO/utilities/kkcoupl.inc"                                   
      COMPLEX*16 KK1(6,1:kkw),AMPK1(1:kkw), KK2(6,1:kkw),AMPK2(1:kkw)
	COMPLEX*16 kkh1(6,1:kkh), AMPKH(1:kkh)
	COMPLEX*16 h1(6), AMPH
      INTEGER k
C                                                                          
C ----------
C BEGIN CODE
C ----------
      if (lswitch) then
         do i=1,6
            w(i,2)  = zem(i,N)
            w(i,3)  = zep(i,N)
            w(i,4)  = zmm(i,N)
            w(i,5)  = zmp(i,N)
            w(i,6)  = ztm(i,N)
            w(i,7)  = ztp(i,N)

            w(i,8)  = ae(i,N)
            w(i,13) = ze(i,N)
            w(i,129) = wbos(i,N)
            w(i,27) = zmu(i,N)
            w(i,32) = amu(i,N)
         enddo
      endif

      do mu = 0,3
         q(mu) = p(mu,2)+p(mu,3)+p(mu,4)+p(mu,5)+p(mu,6)+p(mu,7)
      enddo

      if (.not.lswitch) then        
         CALL OXXXXX(P(0,2), ZERO , lsign(2),+1,W(1,2   ))        
         CALL IXXXXX(P(0,3), ZERO ,-lsign(3),-1,W(1,3   ))        
         CALL OXXXXX(P(0,4), ZERO , lsign(4),+1,W(1,4   ))        
         CALL IXXXXX(P(0,5), ZERO ,-lsign(5),-1,W(1,5   ))        
         CALL OXXXXX(P(0,6), ZERO , lsign(6),+1,W(1,6   ))       
         CALL IXXXXX(P(0,7), ZERO ,-lsign(7),-1,W(1,7   ))
         CALL JIOXXX(W(1,3   ),W(1,2   ),GAL ,ZERO    ,ZERO    ,W(1,8))
         CALL JIOXXX(W(1,3   ),W(1,2   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,14))    
         CALL JIOXXX(W(1,7   ),W(1,6   ),GWF ,WMASS   ,WWIDTH  ,W(1,32))    
         CALL JIOXXX(W(1,5   ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,29)) 
         CALL JIOXXX(W(1,5   ),W(1,4   ),GAL ,ZERO    ,ZERO    ,W(1,35)) 
      endif 

      do mu = 0,3
      call TRIBOSVCARTX(Q(0), WMASS, WWIDTH, MU, -1, W(1,1))         

c      CALL OXXXXX(P(0,2   ),ZERO ,NHEL(2   ),+1*IC(2   ),W(1,2   ))        
c      CALL IXXXXX(P(0,3   ),ZERO ,NHEL(3   ),-1*IC(3   ),W(1,3   ))        
c      CALL OXXXXX(P(0,4   ),ZERO ,NHEL(4   ),+1*IC(4   ),W(1,4   ))        
c      CALL IXXXXX(P(0,5   ),ZERO ,NHEL(5   ),-1*IC(5   ),W(1,5   ))        
c      CALL OXXXXX(P(0,6   ),LMASS ,NHEL(6   ),+1*IC(6   ),W(1,6   ))       
c      CALL IXXXXX(P(0,7   ),ZERO ,NHEL(7   ),-1*IC(7   ),W(1,7   ))        

c      CALL JIOXXX(W(1,3   ),W(1,2   ),GAL ,ZERO    ,AWIDTH  ,W(1,8   )) ! a -> e+ e-   
      CALL FVOXXX(W(1,4   ),W(1,8   ),GAL ,ZERO    ,ZERO    ,W(1,9   ))    
      CALL JIOXXX(W(1,5   ),W(1,9   ),GAL ,ZERO    ,AWIDTH  ,W(1,10  ))    
      CALL FVIXXX(W(1,7   ),W(1,1   ),GWF ,LMASS   ,ZERO    ,W(1,11  ))    
      CALL IOVXXX(W(1,11  ),W(1,6   ),W(1,10  ),GAL ,AMP(1   ))            
      CALL JIOXXX(W(1,5   ),W(1,9   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,12  ))    
      CALL IOVXXX(W(1,11  ),W(1,6   ),W(1,12  ),GZL ,AMP(2   ))            
c      CALL JIOXXX(W(1,3   ),W(1,2   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,13  )) ! z-> e+ e-   
      CALL FVOXXX(W(1,4   ),W(1,13  ),GZL ,ZERO    ,ZERO    ,W(1,14  ))    
      CALL JIOXXX(W(1,5   ),W(1,14  ),GAL ,ZERO    ,AWIDTH  ,W(1,15  ))    
      CALL IOVXXX(W(1,11  ),W(1,6   ),W(1,15  ),GAL ,AMP(3   ))            
      CALL JIOXXX(W(1,5   ),W(1,14  ),GZL ,ZMASS   ,ZWIDTH  ,W(1,16  ))    
      CALL IOVXXX(W(1,11  ),W(1,6   ),W(1,16  ),GZL ,AMP(4   ))            
      CALL JVVXXX(W(1,1   ),W(1,10  ),GWWA ,WMASS   ,WWIDTH  ,W(1,         
     &     17  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,17  ),GWF ,AMP(5   ))            
      CALL JVVXXX(W(1,1   ),W(1,12  ),GWWZ ,WMASS   ,WWIDTH  ,W(1,         
     &     18  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,18  ),GWF ,AMP(6   ))            
      CALL JVVXXX(W(1,1   ),W(1,15  ),GWWA ,WMASS   ,WWIDTH  ,W(1,         
     &     19  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,19  ),GWF ,AMP(7   ))            
      CALL JVVXXX(W(1,1   ),W(1,16  ),GWWZ ,WMASS   ,WWIDTH  ,W(1,         
     &     20  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,20  ),GWF ,AMP(8   ))            
      CALL FVIXXX(W(1,7   ),W(1,12  ),GZN ,ZERO    ,ZERO    ,W(1,21  ))    
      CALL IOVXXX(W(1,21  ),W(1,6   ),W(1,1   ),GWF ,AMP(9   ))            
      CALL FVIXXX(W(1,7   ),W(1,16  ),GZN ,ZERO    ,ZERO    ,W(1,22  ))    
      CALL IOVXXX(W(1,22  ),W(1,6   ),W(1,1   ),GWF ,AMP(10  ))            
      CALL FVOXXX(W(1,9   ),W(1,1   ),GWF ,ZERO    ,ZERO    ,W(1,23  ))    
      CALL JIOXXX(W(1,5   ),W(1,23  ),GWF ,WMASS   ,WWIDTH  ,W(1,24  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,24  ),GWF ,AMP(11  ))            
      CALL FVOXXX(W(1,14  ),W(1,1   ),GWF ,ZERO    ,ZERO    ,W(1,25  ))    
      CALL JIOXXX(W(1,5   ),W(1,25  ),GWF ,WMASS   ,WWIDTH  ,W(1,26  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,26  ),GWF ,AMP(12  ))            
c      CALL JIOXXX(W(1,5   ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,27  ))   ! z-> mu+ mu- 
      CALL FVIXXX(W(1,7   ),W(1,13  ),GZN ,ZERO    ,ZERO    ,W(1,28  ))    
      CALL FVIXXX(W(1,28  ),W(1,27  ),GZN ,ZERO    ,ZERO    ,W(1,29  ))    
      CALL IOVXXX(W(1,29  ),W(1,6   ),W(1,1   ),GWF ,AMP(13  ))            
      CALL FVIXXX(W(1,7   ),W(1,27  ),GZN ,ZERO    ,ZERO    ,W(1,30  ))    
      CALL FVIXXX(W(1,30  ),W(1,13  ),GZN ,ZERO    ,ZERO    ,W(1,31  ))    
      CALL IOVXXX(W(1,31  ),W(1,6   ),W(1,1   ),GWF ,AMP(14  ))            
c      CALL JIOXXX(W(1,5   ),W(1,4   ),GAL ,ZERO    ,AWIDTH  ,W(1,32  ))   ! a -> mu+ mu- 
      CALL JVVXXX(W(1,1   ),W(1,32  ),GWWA ,WMASS   ,WWIDTH  ,W(1,         
     &     33  ))                                                          
      CALL FVOXXX(W(1,2   ),W(1,33  ),GWF ,ZERO    ,ZERO    ,W(1,34  ))    
      CALL JIOXXX(W(1,3   ),W(1,34  ),GWF ,WMASS   ,WWIDTH  ,W(1,35  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,35  ),GWF ,AMP(15  ))            
      CALL JVVXXX(W(1,1   ),W(1,27  ),GWWZ ,WMASS   ,WWIDTH  ,W(1,         
     &     36  ))                                                          
      CALL FVOXXX(W(1,2   ),W(1,36  ),GWF ,ZERO    ,ZERO    ,W(1,37  ))    
      CALL JIOXXX(W(1,3   ),W(1,37  ),GWF ,WMASS   ,WWIDTH  ,W(1,38  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,38  ),GWF ,AMP(16  ))            
      CALL JVVXXX(W(1,1   ),W(1,8   ),GWWA ,WMASS   ,WWIDTH  ,W(1,         
     &     39  ))                                                          
      CALL FVOXXX(W(1,4   ),W(1,39  ),GWF ,ZERO    ,ZERO    ,W(1,40  ))    
      CALL JIOXXX(W(1,5   ),W(1,40  ),GWF ,WMASS   ,WWIDTH  ,W(1,41  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,41  ),GWF ,AMP(17  ))            
      CALL JVVXXX(W(1,1   ),W(1,13  ),GWWZ ,WMASS   ,WWIDTH  ,W(1,         
     &     42  ))                                                          
      CALL FVOXXX(W(1,4   ),W(1,42  ),GWF ,ZERO    ,ZERO    ,W(1,43  ))    
      CALL JIOXXX(W(1,5   ),W(1,43  ),GWF ,WMASS   ,WWIDTH  ,W(1,44  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,44  ),GWF ,AMP(18  ))            
     
	call w3w3xx(w(1,129),w(1,32),w(1,1),w(1,8),gwwaa_k(0,0,0,0),1d0, amp(19))
	call w3w3xx(w(1,129),w(1,27),w(1,1),w(1,8),gwwaz_k(0,0,0,0),1d0, amp(20))
	call w3w3xx(w(1,129),w(1,32),w(1,1),w(1,13),gwwaz_k(0,0,0,0),1d0, amp(21))
	call w3w3xx(w(1,129),w(1,27),w(1,1),w(1,13),gwwzz_k(0,0,0,0),1d0, amp(22))

      CALL FVIXXX(W(1,11  ),W(1,32  ),GAL ,LMASS   ,ZERO    ,W(1,49  ))    
      CALL IOVXXX(W(1,49  ),W(1,6   ),W(1,8   ),GAL ,AMP(23  ))            
      CALL FVIXXX(W(1,11  ),W(1,27  ),GZL ,LMASS   ,ZERO    ,W(1,50  ))    
      CALL IOVXXX(W(1,50  ),W(1,6   ),W(1,8   ),GAL ,AMP(24  ))            
      CALL IOVXXX(W(1,49  ),W(1,6   ),W(1,13  ),GZL ,AMP(25  ))            
      CALL IOVXXX(W(1,50  ),W(1,6   ),W(1,13  ),GZL ,AMP(26  ))            
      CALL JVVXXX(W(1,33  ),W(1,8   ),GWWA ,WMASS   ,WWIDTH  ,W(1,         
     &     51  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,51  ),GWF ,AMP(27  ))            
      CALL JVVXXX(W(1,36  ),W(1,8   ),GWWA ,WMASS   ,WWIDTH  ,W(1,         
     &     52  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,52  ),GWF ,AMP(28  ))            
      CALL JVVXXX(W(1,33  ),W(1,13  ),GWWZ ,WMASS   ,WWIDTH  ,W(1,         
     &     53  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,53  ),GWF ,AMP(29  ))            
      CALL JVVXXX(W(1,36  ),W(1,13  ),GWWZ ,WMASS   ,WWIDTH  ,W(1,         
     &     54  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,54  ),GWF ,AMP(30  ))            
      CALL IOVXXX(W(1,28  ),W(1,6   ),W(1,33  ),GWF ,AMP(31  ))            
      CALL IOVXXX(W(1,28  ),W(1,6   ),W(1,36  ),GWF ,AMP(32  ))            
      CALL FVIXXX(W(1,30  ),W(1,1   ),GWF ,LMASS   ,ZERO    ,W(1,55  ))    
      CALL IOVXXX(W(1,55  ),W(1,6   ),W(1,8   ),GAL ,AMP(33  ))            
      CALL IOVXXX(W(1,55  ),W(1,6   ),W(1,13  ),GZL ,AMP(34  ))            
      CALL FVIXXX(W(1,7   ),W(1,33  ),GWF ,LMASS   ,ZERO    ,W(1,56  ))    
      CALL IOVXXX(W(1,56  ),W(1,6   ),W(1,8   ),GAL ,AMP(35  ))            
      CALL FVIXXX(W(1,7   ),W(1,36  ),GWF ,LMASS   ,ZERO    ,W(1,57  ))    
      CALL IOVXXX(W(1,57  ),W(1,6   ),W(1,8   ),GAL ,AMP(36  ))            
      CALL IOVXXX(W(1,56  ),W(1,6   ),W(1,13  ),GZL ,AMP(37  ))            
      CALL IOVXXX(W(1,57  ),W(1,6   ),W(1,13  ),GZL ,AMP(38  ))            
      CALL FVIXXX(W(1,11  ),W(1,8   ),GAL ,LMASS   ,ZERO    ,W(1,58  ))    
      CALL IOVXXX(W(1,58  ),W(1,6   ),W(1,32  ),GAL ,AMP(39  ))            
      CALL IOVXXX(W(1,58  ),W(1,6   ),W(1,27  ),GZL ,AMP(40  ))            
      CALL FVIXXX(W(1,11  ),W(1,13  ),GZL ,LMASS   ,ZERO    ,W(1,59  ))    
      CALL IOVXXX(W(1,59  ),W(1,6   ),W(1,32  ),GAL ,AMP(41  ))            
      CALL IOVXXX(W(1,59  ),W(1,6   ),W(1,27  ),GZL ,AMP(42  ))            
      CALL JVVXXX(W(1,39  ),W(1,32  ),GWWA ,WMASS   ,WWIDTH  ,W(1,         
     &     60  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,60  ),GWF ,AMP(43  ))            
      CALL JVVXXX(W(1,39  ),W(1,27  ),GWWZ ,WMASS   ,WWIDTH  ,W(1,         
     &     61  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,61  ),GWF ,AMP(44  ))            
      CALL JVVXXX(W(1,42  ),W(1,32  ),GWWA ,WMASS   ,WWIDTH  ,W(1,         
     &     62  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,62  ),GWF ,AMP(45  ))            
      CALL JVVXXX(W(1,42  ),W(1,27  ),GWWZ ,WMASS   ,WWIDTH  ,W(1,         
     &     63  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,63  ),GWF ,AMP(46  ))            
      CALL FVIXXX(W(1,28  ),W(1,1   ),GWF ,LMASS   ,ZERO    ,W(1,64  ))    
      CALL IOVXXX(W(1,64  ),W(1,6   ),W(1,32  ),GAL ,AMP(47  ))            
      CALL IOVXXX(W(1,64  ),W(1,6   ),W(1,27  ),GZL ,AMP(48  ))            
      CALL FVIXXX(W(1,7   ),W(1,39  ),GWF ,LMASS   ,ZERO    ,W(1,65  ))    
      CALL IOVXXX(W(1,65  ),W(1,6   ),W(1,32  ),GAL ,AMP(49  ))            
      CALL IOVXXX(W(1,65  ),W(1,6   ),W(1,27  ),GZL ,AMP(50  ))            
      CALL FVIXXX(W(1,7   ),W(1,42  ),GWF ,LMASS   ,ZERO    ,W(1,66  ))    
      CALL IOVXXX(W(1,66  ),W(1,6   ),W(1,32  ),GAL ,AMP(51  ))            
      CALL IOVXXX(W(1,66  ),W(1,6   ),W(1,27  ),GZL ,AMP(52  ))            
      CALL IOVXXX(W(1,30  ),W(1,6   ),W(1,39  ),GWF ,AMP(53  ))            
      CALL IOVXXX(W(1,30  ),W(1,6   ),W(1,42  ),GWF ,AMP(54  ))            
      CALL FVIXXX(W(1,5   ),W(1,8   ),GAL ,ZERO    ,ZERO    ,W(1,67  ))    
      CALL JIOXXX(W(1,67  ),W(1,4   ),GAL ,ZERO    ,AWIDTH  ,W(1,68  ))    
      CALL IOVXXX(W(1,11  ),W(1,6   ),W(1,68  ),GAL ,AMP(55  ))            
      CALL JIOXXX(W(1,67  ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,69  ))    
      CALL IOVXXX(W(1,11  ),W(1,6   ),W(1,69  ),GZL ,AMP(56  ))            
      CALL FVIXXX(W(1,5   ),W(1,13  ),GZL ,ZERO    ,ZERO    ,W(1,70  ))    
      CALL JIOXXX(W(1,70  ),W(1,4   ),GAL ,ZERO    ,AWIDTH  ,W(1,71  ))    
      CALL IOVXXX(W(1,11  ),W(1,6   ),W(1,71  ),GAL ,AMP(57  ))            
      CALL JIOXXX(W(1,70  ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,72  ))    
      CALL IOVXXX(W(1,11  ),W(1,6   ),W(1,72  ),GZL ,AMP(58  ))            
      CALL JVVXXX(W(1,1   ),W(1,68  ),GWWA ,WMASS   ,WWIDTH  ,W(1,         
     &     73  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,73  ),GWF ,AMP(59  ))            
      CALL JVVXXX(W(1,1   ),W(1,69  ),GWWZ ,WMASS   ,WWIDTH  ,W(1,         
     &     74  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,74  ),GWF ,AMP(60  ))            
      CALL JVVXXX(W(1,1   ),W(1,71  ),GWWA ,WMASS   ,WWIDTH  ,W(1,         
     &     75  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,75  ),GWF ,AMP(61  ))            
      CALL JVVXXX(W(1,1   ),W(1,72  ),GWWZ ,WMASS   ,WWIDTH  ,W(1,         
     &     76  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,76  ),GWF ,AMP(62  ))            
      CALL FVIXXX(W(1,7   ),W(1,69  ),GZN ,ZERO    ,ZERO    ,W(1,77  ))    
      CALL IOVXXX(W(1,77  ),W(1,6   ),W(1,1   ),GWF ,AMP(63  ))            
      CALL FVIXXX(W(1,7   ),W(1,72  ),GZN ,ZERO    ,ZERO    ,W(1,78  ))    
      CALL IOVXXX(W(1,78  ),W(1,6   ),W(1,1   ),GWF ,AMP(64  ))            
      CALL FVOXXX(W(1,4   ),W(1,1   ),GWF ,ZERO    ,ZERO    ,W(1,79  ))    
      CALL JIOXXX(W(1,5   ),W(1,79  ),GWF ,WMASS   ,WWIDTH  ,W(1,80  ))    
      CALL FVOXXX(W(1,2   ),W(1,80  ),GWF ,ZERO    ,ZERO    ,W(1,81  ))    
      CALL JIOXXX(W(1,3   ),W(1,81  ),GWF ,WMASS   ,WWIDTH  ,W(1,82  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,82  ),GWF ,AMP(65  ))            
      CALL FVOXXX(W(1,79  ),W(1,13  ),GZN ,ZERO    ,ZERO    ,W(1,83  ))    
      CALL JIOXXX(W(1,5   ),W(1,83  ),GWF ,WMASS   ,WWIDTH  ,W(1,84  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,84  ),GWF ,AMP(66  ))            
      CALL JVVXXX(W(1,80  ),W(1,8   ),GWWA ,WMASS   ,WWIDTH  ,W(1,         
     &     85  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,85  ),GWF ,AMP(67  ))            
      CALL JVVXXX(W(1,80  ),W(1,13  ),GWWZ ,WMASS   ,WWIDTH  ,W(1,         
     &     86  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,86  ),GWF ,AMP(68  ))            
      CALL IOVXXX(W(1,28  ),W(1,6   ),W(1,80  ),GWF ,AMP(69  ))            
      CALL FVIXXX(W(1,7   ),W(1,80  ),GWF ,LMASS   ,ZERO    ,W(1,87  ))    
      CALL IOVXXX(W(1,87  ),W(1,6   ),W(1,8   ),GAL ,AMP(70  ))            
      CALL IOVXXX(W(1,87  ),W(1,6   ),W(1,13  ),GZL ,AMP(71  ))            
      CALL JIOXXX(W(1,67  ),W(1,79  ),GWF ,WMASS   ,WWIDTH  ,W(1,88  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,88  ),GWF ,AMP(72  ))            
      CALL JIOXXX(W(1,70  ),W(1,79  ),GWF ,WMASS   ,WWIDTH  ,W(1,89  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,89  ),GWF ,AMP(73  ))            
      CALL FVOXXX(W(1,2   ),W(1,32  ),GAL ,ZERO    ,ZERO    ,W(1,90  ))    
      CALL JIOXXX(W(1,3   ),W(1,90  ),GAL ,ZERO    ,AWIDTH  ,W(1,91  ))    
      CALL IOVXXX(W(1,11  ),W(1,6   ),W(1,91  ),GAL ,AMP(74  ))            
      CALL JIOXXX(W(1,3   ),W(1,90  ),GZL ,ZMASS   ,ZWIDTH  ,W(1,92  ))    
      CALL IOVXXX(W(1,11  ),W(1,6   ),W(1,92  ),GZL ,AMP(75  ))            
      CALL FVOXXX(W(1,2   ),W(1,27  ),GZL ,ZERO    ,ZERO    ,W(1,93  ))    
      CALL JIOXXX(W(1,3   ),W(1,93  ),GAL ,ZERO    ,AWIDTH  ,W(1,94  ))    
      CALL IOVXXX(W(1,11  ),W(1,6   ),W(1,94  ),GAL ,AMP(76  ))            
      CALL JIOXXX(W(1,3   ),W(1,93  ),GZL ,ZMASS   ,ZWIDTH  ,W(1,95  ))    
      CALL IOVXXX(W(1,11  ),W(1,6   ),W(1,95  ),GZL ,AMP(77  ))            
      CALL JVVXXX(W(1,1   ),W(1,91  ),GWWA ,WMASS   ,WWIDTH  ,W(1,         
     &     96  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,96  ),GWF ,AMP(78  ))            
      CALL JVVXXX(W(1,1   ),W(1,92  ),GWWZ ,WMASS   ,WWIDTH  ,W(1,         
     &     97  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,97  ),GWF ,AMP(79  ))            
      CALL JVVXXX(W(1,1   ),W(1,94  ),GWWA ,WMASS   ,WWIDTH  ,W(1,         
     &     98  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,98  ),GWF ,AMP(80  ))            
      CALL JVVXXX(W(1,1   ),W(1,95  ),GWWZ ,WMASS   ,WWIDTH  ,W(1,         
     &     99  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,99  ),GWF ,AMP(81  ))            
      CALL FVIXXX(W(1,7   ),W(1,92  ),GZN ,ZERO    ,ZERO    ,W(1,100 ))    
      CALL IOVXXX(W(1,100 ),W(1,6   ),W(1,1   ),GWF ,AMP(82  ))            
      CALL FVIXXX(W(1,7   ),W(1,95  ),GZN ,ZERO    ,ZERO    ,W(1,101 ))    
      CALL IOVXXX(W(1,101 ),W(1,6   ),W(1,1   ),GWF ,AMP(83  ))            
      CALL FVOXXX(W(1,90  ),W(1,1   ),GWF ,ZERO    ,ZERO    ,W(1,102 ))    
      CALL JIOXXX(W(1,3   ),W(1,102 ),GWF ,WMASS   ,WWIDTH  ,W(1,103 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,103 ),GWF ,AMP(84  ))            
      CALL FVOXXX(W(1,93  ),W(1,1   ),GWF ,ZERO    ,ZERO    ,W(1,104 ))    
      CALL JIOXXX(W(1,3   ),W(1,104 ),GWF ,WMASS   ,WWIDTH  ,W(1,105 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,105 ),GWF ,AMP(85  ))            
      CALL FVIXXX(W(1,3   ),W(1,32  ),GAL ,ZERO    ,ZERO    ,W(1,106 ))    
      CALL JIOXXX(W(1,106 ),W(1,2   ),GAL ,ZERO    ,AWIDTH  ,W(1,107 ))    
      CALL IOVXXX(W(1,11  ),W(1,6   ),W(1,107 ),GAL ,AMP(86  ))            
      CALL JIOXXX(W(1,106 ),W(1,2   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,108 ))    
      CALL IOVXXX(W(1,11  ),W(1,6   ),W(1,108 ),GZL ,AMP(87  ))            
      CALL FVIXXX(W(1,3   ),W(1,27  ),GZL ,ZERO    ,ZERO    ,W(1,109 ))    
      CALL JIOXXX(W(1,109 ),W(1,2   ),GAL ,ZERO    ,AWIDTH  ,W(1,110 ))    
      CALL IOVXXX(W(1,11  ),W(1,6   ),W(1,110 ),GAL ,AMP(88  ))            
      CALL JIOXXX(W(1,109 ),W(1,2   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,111 ))    
      CALL IOVXXX(W(1,11  ),W(1,6   ),W(1,111 ),GZL ,AMP(89  ))            
      CALL JVVXXX(W(1,1   ),W(1,107 ),GWWA ,WMASS   ,WWIDTH  ,W(1,         
     &     112 ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,112 ),GWF ,AMP(90  ))            
      CALL JVVXXX(W(1,1   ),W(1,108 ),GWWZ ,WMASS   ,WWIDTH  ,W(1,         
     &     113 ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,113 ),GWF ,AMP(91  ))            
      CALL JVVXXX(W(1,1   ),W(1,110 ),GWWA ,WMASS   ,WWIDTH  ,W(1,         
     &     114 ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,114 ),GWF ,AMP(92  ))            
      CALL JVVXXX(W(1,1   ),W(1,111 ),GWWZ ,WMASS   ,WWIDTH  ,W(1,         
     &     115 ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,115 ),GWF ,AMP(93  ))            
      CALL FVIXXX(W(1,7   ),W(1,108 ),GZN ,ZERO    ,ZERO    ,W(1,116 ))    
      CALL IOVXXX(W(1,116 ),W(1,6   ),W(1,1   ),GWF ,AMP(94  ))            
      CALL FVIXXX(W(1,7   ),W(1,111 ),GZN ,ZERO    ,ZERO    ,W(1,117 ))    
      CALL IOVXXX(W(1,117 ),W(1,6   ),W(1,1   ),GWF ,AMP(95  ))            
      CALL FVOXXX(W(1,2   ),W(1,1   ),GWF ,ZERO    ,ZERO    ,W(1,118 ))    
      CALL FVOXXX(W(1,118 ),W(1,27  ),GZN ,ZERO    ,ZERO    ,W(1,119 ))    
      CALL JIOXXX(W(1,3   ),W(1,119 ),GWF ,WMASS   ,WWIDTH  ,W(1,120 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,120 ),GWF ,AMP(96  ))            
      CALL JIOXXX(W(1,3   ),W(1,118 ),GWF ,WMASS   ,WWIDTH  ,W(1,121 ))    
      CALL FVOXXX(W(1,4   ),W(1,121 ),GWF ,ZERO    ,ZERO    ,W(1,122 ))    
      CALL JIOXXX(W(1,5   ),W(1,122 ),GWF ,WMASS   ,WWIDTH  ,W(1,123 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,123 ),GWF ,AMP(97  ))            
      CALL JIOXXX(W(1,106 ),W(1,118 ),GWF ,WMASS   ,WWIDTH  ,W(1,124 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,124 ),GWF ,AMP(98  ))            
      CALL JIOXXX(W(1,109 ),W(1,118 ),GWF ,WMASS   ,WWIDTH  ,W(1,125 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,125 ),GWF ,AMP(99  ))            
      CALL JVVXXX(W(1,121 ),W(1,32  ),GWWA ,WMASS   ,WWIDTH  ,W(1,         
     &     126 ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,126 ),GWF ,AMP(100 ))            
      CALL JVVXXX(W(1,121 ),W(1,27  ),GWWZ ,WMASS   ,WWIDTH  ,W(1,         
     &     127 ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,127 ),GWF ,AMP(101 ))            
      CALL FVIXXX(W(1,7   ),W(1,121 ),GWF ,LMASS   ,ZERO    ,W(1,128 ))    
      CALL IOVXXX(W(1,128 ),W(1,6   ),W(1,32  ),GAL ,AMP(102 ))            
      CALL IOVXXX(W(1,128 ),W(1,6   ),W(1,27  ),GZL ,AMP(103 ))            
      CALL IOVXXX(W(1,30  ),W(1,6   ),W(1,121 ),GWF ,AMP(104 ))            

c kk graph
	do k=1,kkhw
	Call JVVXXX(w(1,1),w(1,27),gwwz_k(k,0,0),w1mass_k(k),w1width_k(k), KK1(1,k)) ! like graph 30
	Call VVVXXX(w(1,129),kk1(1,k),w(1,13),gwwz_k(k,0,0), ampk1(k))

	Call JVVXXX(w(1,1),w(1,13),gwwz_k(k,0,0),w1mass_k(k),w1width_k(k), KK2(1,k)) ! like graph 
	Call VVVXXX(w(1,129),kk2(1,k),w(1,27),gwwz_k(k,0,0), ampk2(k))
	enddo

cc higgs graphs
      if(hswitchzzw) then
c SM higgs graph
	CALL HVVXXX(W(1,27), W(1,13), gzzh, hmass,hwidth, h1(1))
	CALL VVSXXX(W(1,1), W(1,129),h1(1), gwwh, AMPH)
      do k=1,kkhh
c KK higgs graph
	CALL HVVXXX(W(1,27), W(1,13), gzzh_k(0,0,k), h1mass_k(k), 
     &	h1width_k(k), kkh1(1,k))
	CALL VVSXXX(W(1,1), W(1,129),kkh1(1,k), gwwh_k(0,0,k), AMPKH(k))
      enddo
      endif

      zzw(mu)    = -AMP(   1)-AMP(   2)-AMP(   3)-AMP(   4)-AMP(   5)
     &             -AMP(   6)-AMP(   7)-AMP(   8)-AMP(   9)-AMP(  10)
     &             -AMP(  11)-AMP(  12)-AMP(  13)-AMP(  14)-AMP(  15)
     &             -AMP(  16)-AMP(  17)-AMP(  18)-AMP(  19)-AMP(  20)
     &             -AMP(  21)-AMP(  22)-AMP(  23)-AMP(  24)-AMP(  25)
     &             -AMP(  26)-AMP(  27)-AMP(  28)-AMP(  29)-AMP(  30)
     &             -AMP(  31)-AMP(  32)-AMP(  33)-AMP(  34)-AMP(  35)
     &             -AMP(  36)-AMP(  37)-AMP(  38)-AMP(  39)-AMP(  40)
     &             -AMP(  41)-AMP(  42)-AMP(  43)-AMP(  44)-AMP(  45)
     &             -AMP(  46)-AMP(  47)-AMP(  48)-AMP(  49)-AMP(  50)
     &             -AMP(  51)-AMP(  52)-AMP(  53)-AMP(  54)-AMP(  55)
     &             -AMP(  56)-AMP(  57)-AMP(  58)-AMP(  59)-AMP(  60)
     &             -AMP(  61)-AMP(  62)-AMP(  63)-AMP(  64)-AMP(  65)
     &             -AMP(  66)-AMP(  67)-AMP(  68)-AMP(  69)-AMP(  70)
     &             -AMP(  71)-AMP(  72)-AMP(  73)-AMP(  74)-AMP(  75)
     &             -AMP(  76)-AMP(  77)-AMP(  78)-AMP(  79)-AMP(  80)
     &             -AMP(  81)-AMP(  82)-AMP(  83)-AMP(  84)-AMP(  85)
     &             -AMP(  86)-AMP(  87)-AMP(  88)-AMP(  89)-AMP(  90)
     &             -AMP(  91)-AMP(  92)-AMP(  93)-AMP(  94)-AMP(  95)
     &             -AMP(  96)-AMP(  97)-AMP(  98)-AMP(  99)-AMP( 100)
     &             -AMP( 101)-AMP( 102)-AMP( 103)-AMP( 104)
      do k=1,kkhw
      zzw(mu)=zzw(mu)-AMPK1(k)-AMPK2(k)
      enddo

	if (hswitchzzw) then
	zzw(mu)=zzw(mu)-AMPH
	do k=1, kkhh
	zzw(mu)=zzw(mu)-AMPKH(k)
	enddo
	endif

      enddo !mu

      zzw(4) = dcmplx(q(0),q(3))
      zzw(5) = dcmplx(q(1),q(2))

      END
