c
c in this file leptonic tensors needed for qq -> ZZZ, ZZZ -> 6l
c are computed for specific helicities (h)
c
c ------------------------------------------------------------
c ------------------------------------------------------------

      subroutine ATOZZZ(P,N,h,ZZZtensor)

      IMPLICIT NONE
      DOUBLE PRECISION P(0:3,2:7)
      COMPLEX*16 ZZZTENSOR(0:5)
      integer lsign(2:7,8),ll,mu,nu,h,N

      !possible lepton helicities
      data (lsign(ll,1),ll=2,7) / -1, -1, -1, -1, -1, -1/  !h=1
      data (lsign(ll,2),ll=2,7) / -1, -1,  1,  1, -1, -1/  !h=2
      data (lsign(ll,3),ll=2,7) / -1, -1, -1, -1,  1,  1/  !h=3
      data (lsign(ll,4),ll=2,7) / -1, -1,  1,  1,  1,  1/  !h=4
      data (lsign(ll,5),ll=2,7) /  1,  1, -1, -1, -1, -1/  !h=5
      data (lsign(ll,6),ll=2,7) /  1,  1,  1,  1, -1, -1/  !h=6
      data (lsign(ll,7),ll=2,7) /  1,  1, -1, -1,  1,  1/  !h=7
      data (lsign(ll,8),ll=2,7) /  1,  1,  1,  1,  1,  1/  !h=8

      call ATOZZZ1(P,N,lsign(2,h),zzztensor(0))

      ! helicity combi Nr. h is selected

      end

c-------------------------------------------------------------------

      SUBROUTINE ATOZZZ1(P,N,lsign,zzztensor)
C  
C Generated by MadGraph II Version 3.0. Updated 02/19/04                
C RETURNS AMPLITUDE SQUARED SUMMED/AVG OVER COLORS
C FOR THE POINT WITH EXTERNAL LINES W(0:6,NEXTERNAL)
C  
C FOR PROCESS : a -> e- e+ mu- mu+ ta- ta+  
C  
      IMPLICIT NONE
C  
C CONSTANTS
C  
      INTEGER    NGRAPHS 
      PARAMETER (NGRAPHS= 174) 
      INTEGER    NWAVEFUNCS
      PARAMETER (NWAVEFUNCS= 139) 
      DOUBLE PRECISION     ZERO
      PARAMETER (ZERO=0D0)
C  
C ARGUMENTS 
C  
      DOUBLE PRECISION P(0:3,2:7), Q(0:3)
      INTEGER N
      COMPLEX*16 zzztensor(0:5)
      INTEGER lsign(2:7)
C  
C LOCAL VARIABLES 
C  
      INTEGER I,J, mu
      COMPLEX*16 AMP(NGRAPHS)
      COMPLEX*16 W(6,NWAVEFUNCS)
c  lepton spinors and Z/A polarization vectors
#include "tensor.inc"

      logical lswitch
      parameter (lswitch=.true.)
C  
C GLOBAL VARIABLES
C  
#include "VBFNLO/utilities/coupl.inc"                                  
C                                                                          
C ----------
C BEGIN CODE
C ----------
      if (lswitch) then
         do i=1,6
            w(i,2)  = zem(i,N)
            w(i,3)  = zep(i,N)
            w(i,4)  = zmm(i,N)
            w(i,5)  = zmp(i,N)
            w(i,6)  = ztm(i,N)
            w(i,7)  = ztp(i,N)
            w(i,8)  = ae(i,N)
            w(i,14) = ze(i,N)
            w(i,22) = atau(i,N)
            w(i,26) = ztau(i,N)
         enddo
      endif

      do mu = 0,3
         q(mu) = p(mu,2)+p(mu,3)+p(mu,4)+p(mu,5)+p(mu,6)+p(mu,7)
      enddo

      if (.not.lswitch) then        
         CALL OXXXXX(P(0,2), ZERO , lsign(2),+1,W(1,2   ))        
         CALL IXXXXX(P(0,3), ZERO ,-lsign(3),-1,W(1,3   ))        
         CALL OXXXXX(P(0,4), ZERO , lsign(4),+1,W(1,4   ))        
         CALL IXXXXX(P(0,5), ZERO ,-lsign(5),-1,W(1,5   ))        
         CALL OXXXXX(P(0,6),LMASS , lsign(6),+1,W(1,6   ))       
         CALL IXXXXX(P(0,7),LMASS ,-lsign(7),-1,W(1,7   ))
         CALL JIOXXX(W(1,3   ),W(1,2   ),GAL ,ZERO    ,ZERO    ,W(1,8   ))  
         CALL JIOXXX(W(1,3   ),W(1,2   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,14  ))
         CALL JIOXXX(W(1,7   ),W(1,6   ),GAL ,ZERO    ,ZERO    ,W(1,22  ))
         CALL JIOXXX(W(1,7   ),W(1,6   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,26  ))
      endif 

      do mu = 0,3
      call TRIBOSVCARTX(Q(0), ZERO, ZERO, MU, -1, W(1,1))      
      CALL FVOXXX(W(1,4   ),W(1,8   ),GAL ,ZERO    ,ZERO    ,W(1,9   ))    
      CALL JIOXXX(W(1,5   ),W(1,9   ),GAL ,ZERO    ,ZERO    ,W(1,10  ))    
      CALL FVOXXX(W(1,6   ),W(1,10  ),GAL ,LMASS   ,ZERO    ,W(1,11  ))    
      CALL IOVXXX(W(1,7   ),W(1,11  ),W(1,1   ),GAL ,AMP(1   ))            
      CALL JIOXXX(W(1,5   ),W(1,9   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,12  ))    
      CALL FVOXXX(W(1,6   ),W(1,12  ),GZL ,LMASS   ,ZERO    ,W(1,13  ))    
      CALL IOVXXX(W(1,7   ),W(1,13  ),W(1,1   ),GAL ,AMP(2   ))                
      CALL FVOXXX(W(1,4   ),W(1,14  ),GZL ,ZERO    ,ZERO    ,W(1,15  ))    
      CALL JIOXXX(W(1,5   ),W(1,15  ),GAL ,ZERO    ,ZERO    ,W(1,16  ))    
      CALL FVOXXX(W(1,6   ),W(1,16  ),GAL ,LMASS   ,ZERO    ,W(1,17  ))    
      CALL IOVXXX(W(1,7   ),W(1,17  ),W(1,1   ),GAL ,AMP(3   ))            
      CALL JIOXXX(W(1,5   ),W(1,15  ),GZL ,ZMASS   ,ZWIDTH  ,W(1,18  ))    
      CALL FVOXXX(W(1,6   ),W(1,18  ),GZL ,LMASS   ,ZERO    ,W(1,19  ))    
      CALL IOVXXX(W(1,7   ),W(1,19  ),W(1,1   ),GAL ,AMP(4   ))            
      CALL FVOXXX(W(1,6   ),W(1,1   ),GAL ,LMASS   ,ZERO    ,W(1,20  ))    
      CALL IOVXXX(W(1,7   ),W(1,20  ),W(1,10  ),GAL ,AMP(5   ))            
      CALL IOVXXX(W(1,7   ),W(1,20  ),W(1,12  ),GZL ,AMP(6   ))            
      CALL IOVXXX(W(1,7   ),W(1,20  ),W(1,16  ),GAL ,AMP(7   ))            
      CALL IOVXXX(W(1,7   ),W(1,20  ),W(1,18  ),GZL ,AMP(8   ))            
      CALL FVIXXX(W(1,5   ),W(1,1   ),GAL ,ZERO    ,ZERO    ,W(1,21  ))     
      CALL JIOXXX(W(1,21  ),W(1,4   ),GAL ,ZERO    ,ZERO    ,W(1,23  ))    
      CALL FVOXXX(W(1,2   ),W(1,22  ),GAL ,ZERO    ,ZERO    ,W(1,24  ))    
      CALL IOVXXX(W(1,3   ),W(1,24  ),W(1,23  ),GAL ,AMP(9   ))            
      CALL JIOXXX(W(1,21  ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,25  ))    
      CALL IOVXXX(W(1,3   ),W(1,24  ),W(1,25  ),GZL ,AMP(10  ))               
      CALL FVOXXX(W(1,2   ),W(1,26  ),GZL ,ZERO    ,ZERO    ,W(1,27  ))    
      CALL IOVXXX(W(1,3   ),W(1,27  ),W(1,23  ),GAL ,AMP(11  ))            
      CALL IOVXXX(W(1,3   ),W(1,27  ),W(1,25  ),GZL ,AMP(12  ))            
      CALL FVIXXX(W(1,3   ),W(1,22  ),GAL ,ZERO    ,ZERO    ,W(1,28  ))    
      CALL IOVXXX(W(1,28  ),W(1,2   ),W(1,23  ),GAL ,AMP(13  ))            
      CALL IOVXXX(W(1,28  ),W(1,2   ),W(1,25  ),GZL ,AMP(14  ))            
      CALL FVIXXX(W(1,3   ),W(1,26  ),GZL ,ZERO    ,ZERO    ,W(1,29  ))    
      CALL IOVXXX(W(1,29  ),W(1,2   ),W(1,23  ),GAL ,AMP(15  ))            
      CALL IOVXXX(W(1,29  ),W(1,2   ),W(1,25  ),GZL ,AMP(16  ))            
      CALL FVIXXX(W(1,21  ),W(1,8   ),GAL ,ZERO    ,ZERO    ,W(1,30  ))    
      CALL IOVXXX(W(1,30  ),W(1,4   ),W(1,22  ),GAL ,AMP(17  ))            
      CALL IOVXXX(W(1,30  ),W(1,4   ),W(1,26  ),GZL ,AMP(18  ))            
      CALL FVIXXX(W(1,21  ),W(1,14  ),GZL ,ZERO    ,ZERO    ,W(1,31  ))    
      CALL IOVXXX(W(1,31  ),W(1,4   ),W(1,22  ),GAL ,AMP(19  ))            
      CALL IOVXXX(W(1,31  ),W(1,4   ),W(1,26  ),GZL ,AMP(20  ))            
      CALL FVOXXX(W(1,9   ),W(1,1   ),GAL ,ZERO    ,ZERO    ,W(1,32  ))    
      CALL JIOXXX(W(1,5   ),W(1,32  ),GAL ,ZERO    ,ZERO    ,W(1,33  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,33  ),GAL ,AMP(21  ))            
      CALL JIOXXX(W(1,5   ),W(1,32  ),GZL ,ZMASS   ,ZWIDTH  ,W(1,34  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,34  ),GZL ,AMP(22  ))            
      CALL FVOXXX(W(1,15  ),W(1,1   ),GAL ,ZERO    ,ZERO    ,W(1,35  ))    
      CALL JIOXXX(W(1,5   ),W(1,35  ),GAL ,ZERO    ,ZERO    ,W(1,36  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,36  ),GAL ,AMP(23  ))            
      CALL JIOXXX(W(1,5   ),W(1,35  ),GZL ,ZMASS   ,ZWIDTH  ,W(1,37  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,37  ),GZL ,AMP(24  ))            
c      CALL HIOXXX(W(1,7   ),W(1,6   ),GHTAU ,HMASS   ,HWIDTH  ,W(1,        
c     &     38  ))                                                          
c      CALL VVSXXX(W(1,25  ),W(1,14  ),W(1,38  ),GZZH ,AMP(25  ))           
      CALL FVOXXX(W(1,6   ),W(1,8   ),GAL ,LMASS   ,ZERO    ,W(1,39  ))    
      CALL JIOXXX(W(1,7   ),W(1,39  ),GAL ,ZERO    ,ZERO    ,W(1,40  ))    
      CALL IOVXXX(W(1,21  ),W(1,4   ),W(1,40  ),GAL ,AMP(26  ))            
      CALL JIOXXX(W(1,7   ),W(1,39  ),GZL ,ZMASS   ,ZWIDTH  ,W(1,41  ))    
      CALL IOVXXX(W(1,21  ),W(1,4   ),W(1,41  ),GZL ,AMP(27  ))            
      CALL FVOXXX(W(1,6   ),W(1,14  ),GZL ,LMASS   ,ZERO    ,W(1,42  ))    
      CALL JIOXXX(W(1,7   ),W(1,42  ),GAL ,ZERO    ,ZERO    ,W(1,43  ))    
      CALL IOVXXX(W(1,21  ),W(1,4   ),W(1,43  ),GAL ,AMP(28  ))            
      CALL JIOXXX(W(1,7   ),W(1,42  ),GZL ,ZMASS   ,ZWIDTH  ,W(1,44  ))    
      CALL IOVXXX(W(1,21  ),W(1,4   ),W(1,44  ),GZL ,AMP(29  ))            
      CALL FVIXXX(W(1,7   ),W(1,8   ),GAL ,LMASS   ,ZERO    ,W(1,45  ))    
      CALL IOVXXX(W(1,45  ),W(1,6   ),W(1,23  ),GAL ,AMP(30  ))            
      CALL IOVXXX(W(1,45  ),W(1,6   ),W(1,25  ),GZL ,AMP(31  ))            
      CALL FVIXXX(W(1,7   ),W(1,14  ),GZL ,LMASS   ,ZERO    ,W(1,46  ))    
      CALL IOVXXX(W(1,46  ),W(1,6   ),W(1,23  ),GAL ,AMP(32  ))            
      CALL IOVXXX(W(1,46  ),W(1,6   ),W(1,25  ),GZL ,AMP(33  ))            
      CALL JIOXXX(W(1,21  ),W(1,9   ),GAL ,ZERO    ,ZERO    ,W(1,47  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,47  ),GAL ,AMP(34  ))            
      CALL JIOXXX(W(1,21  ),W(1,9   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,48  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,48  ),GZL ,AMP(35  ))            
      CALL JIOXXX(W(1,21  ),W(1,15  ),GAL ,ZERO    ,ZERO    ,W(1,49  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,49  ),GAL ,AMP(36  ))            
      CALL JIOXXX(W(1,21  ),W(1,15  ),GZL ,ZMASS   ,ZWIDTH  ,W(1,50  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,50  ),GZL ,AMP(37  ))            
      CALL JIOXXX(W(1,5   ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,51  ))    
      CALL FVIXXX(W(1,7   ),W(1,1   ),GAL ,LMASS   ,ZERO    ,W(1,52  ))    
c      CALL HVVXXX(W(1,51  ),W(1,14  ),GZZH ,HMASS   ,HWIDTH  ,W(1,         
c     &     53  ))                                                          
c      CALL IOSXXX(W(1,52  ),W(1,6   ),W(1,53  ),GHTAU ,AMP(38  ))          
      CALL JIOXXX(W(1,5   ),W(1,4   ),GAL ,ZERO    ,ZERO    ,W(1,54  ))    
      CALL IOVXXX(W(1,45  ),W(1,20  ),W(1,54  ),GAL ,AMP(39  ))            
      CALL IOVXXX(W(1,45  ),W(1,20  ),W(1,51  ),GZL ,AMP(40  ))            
      CALL IOVXXX(W(1,46  ),W(1,20  ),W(1,54  ),GAL ,AMP(41  ))            
      CALL IOVXXX(W(1,46  ),W(1,20  ),W(1,51  ),GZL ,AMP(42  ))            
      CALL FVIXXX(W(1,7   ),W(1,54  ),GAL ,LMASS   ,ZERO    ,W(1,55  ))    
      CALL IOVXXX(W(1,55  ),W(1,20  ),W(1,8   ),GAL ,AMP(43  ))            
      CALL FVIXXX(W(1,7   ),W(1,51  ),GZL ,LMASS   ,ZERO    ,W(1,56  ))    
      CALL IOVXXX(W(1,56  ),W(1,20  ),W(1,8   ),GAL ,AMP(44  ))            
      CALL IOVXXX(W(1,55  ),W(1,20  ),W(1,14  ),GZL ,AMP(45  ))            
      CALL IOVXXX(W(1,56  ),W(1,20  ),W(1,14  ),GZL ,AMP(46  ))            
c      CALL HIOXXX(W(1,7   ),W(1,20  ),GHTAU ,HMASS   ,HWIDTH  ,W(1,        
c     &     57  ))                                                          
c      CALL VVSXXX(W(1,51  ),W(1,14  ),W(1,57  ),GZZH ,AMP(47  ))           
      CALL IOVXXX(W(1,52  ),W(1,39  ),W(1,54  ),GAL ,AMP(48  ))            
      CALL IOVXXX(W(1,52  ),W(1,39  ),W(1,51  ),GZL ,AMP(49  ))            
      CALL IOVXXX(W(1,52  ),W(1,42  ),W(1,54  ),GAL ,AMP(50  ))            
      CALL IOVXXX(W(1,52  ),W(1,42  ),W(1,51  ),GZL ,AMP(51  ))            
      CALL IOVXXX(W(1,55  ),W(1,39  ),W(1,1   ),GAL ,AMP(52  ))            
      CALL IOVXXX(W(1,56  ),W(1,39  ),W(1,1   ),GAL ,AMP(53  ))            
      CALL IOVXXX(W(1,55  ),W(1,42  ),W(1,1   ),GAL ,AMP(54  ))            
      CALL IOVXXX(W(1,56  ),W(1,42  ),W(1,1   ),GAL ,AMP(55  ))            
      CALL FVOXXX(W(1,6   ),W(1,54  ),GAL ,LMASS   ,ZERO    ,W(1,58  ))    
      CALL IOVXXX(W(1,52  ),W(1,58  ),W(1,8   ),GAL ,AMP(56  ))            
      CALL FVOXXX(W(1,6   ),W(1,51  ),GZL ,LMASS   ,ZERO    ,W(1,59  ))    
      CALL IOVXXX(W(1,52  ),W(1,59  ),W(1,8   ),GAL ,AMP(57  ))            
      CALL IOVXXX(W(1,52  ),W(1,58  ),W(1,14  ),GZL ,AMP(58  ))            
      CALL IOVXXX(W(1,52  ),W(1,59  ),W(1,14  ),GZL ,AMP(59  ))            
      CALL IOVXXX(W(1,45  ),W(1,58  ),W(1,1   ),GAL ,AMP(60  ))            
      CALL IOVXXX(W(1,45  ),W(1,59  ),W(1,1   ),GAL ,AMP(61  ))            
      CALL IOVXXX(W(1,46  ),W(1,58  ),W(1,1   ),GAL ,AMP(62  ))            
      CALL IOVXXX(W(1,46  ),W(1,59  ),W(1,1   ),GAL ,AMP(63  ))            
      CALL FVIXXX(W(1,5   ),W(1,8   ),GAL ,ZERO    ,ZERO    ,W(1,60  ))    
      CALL JIOXXX(W(1,60  ),W(1,4   ),GAL ,ZERO    ,ZERO    ,W(1,61  ))    
      CALL IOVXXX(W(1,52  ),W(1,6   ),W(1,61  ),GAL ,AMP(64  ))            
      CALL JIOXXX(W(1,60  ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,62  ))    
      CALL IOVXXX(W(1,52  ),W(1,6   ),W(1,62  ),GZL ,AMP(65  ))            
      CALL FVIXXX(W(1,5   ),W(1,14  ),GZL ,ZERO    ,ZERO    ,W(1,63  ))    
      CALL JIOXXX(W(1,63  ),W(1,4   ),GAL ,ZERO    ,ZERO    ,W(1,64  ))    
      CALL IOVXXX(W(1,52  ),W(1,6   ),W(1,64  ),GAL ,AMP(66  ))            
      CALL JIOXXX(W(1,63  ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,65  ))    
      CALL IOVXXX(W(1,52  ),W(1,6   ),W(1,65  ),GZL ,AMP(67  ))            
      CALL JIOXXX(W(1,7   ),W(1,20  ),GAL ,ZERO    ,ZERO    ,W(1,66  ))    
      CALL IOVXXX(W(1,60  ),W(1,4   ),W(1,66  ),GAL ,AMP(68  ))            
      CALL JIOXXX(W(1,7   ),W(1,20  ),GZL ,ZMASS   ,ZWIDTH  ,W(1,67  ))    
      CALL IOVXXX(W(1,60  ),W(1,4   ),W(1,67  ),GZL ,AMP(69  ))            
      CALL IOVXXX(W(1,63  ),W(1,4   ),W(1,66  ),GAL ,AMP(70  ))            
      CALL IOVXXX(W(1,63  ),W(1,4   ),W(1,67  ),GZL ,AMP(71  ))            
      CALL FVOXXX(W(1,4   ),W(1,1   ),GAL ,ZERO    ,ZERO    ,W(1,68  ))    
      CALL JIOXXX(W(1,5   ),W(1,68  ),GAL ,ZERO    ,ZERO    ,W(1,69  ))    
      CALL FVIXXX(W(1,3   ),W(1,69  ),GAL ,ZERO    ,ZERO    ,W(1,70  ))    
      CALL IOVXXX(W(1,70  ),W(1,2   ),W(1,22  ),GAL ,AMP(72  ))            
      CALL IOVXXX(W(1,70  ),W(1,2   ),W(1,26  ),GZL ,AMP(73  ))            
      CALL JIOXXX(W(1,5   ),W(1,68  ),GZL ,ZMASS   ,ZWIDTH  ,W(1,71  ))    
      CALL FVIXXX(W(1,3   ),W(1,71  ),GZL ,ZERO    ,ZERO    ,W(1,72  ))    
      CALL IOVXXX(W(1,72  ),W(1,2   ),W(1,22  ),GAL ,AMP(74  ))            
      CALL IOVXXX(W(1,72  ),W(1,2   ),W(1,26  ),GZL ,AMP(75  ))            
      CALL FVOXXX(W(1,2   ),W(1,69  ),GAL ,ZERO    ,ZERO    ,W(1,73  ))    
      CALL IOVXXX(W(1,3   ),W(1,73  ),W(1,22  ),GAL ,AMP(76  ))            
      CALL IOVXXX(W(1,3   ),W(1,73  ),W(1,26  ),GZL ,AMP(77  ))            
      CALL FVOXXX(W(1,2   ),W(1,71  ),GZL ,ZERO    ,ZERO    ,W(1,74  ))    
      CALL IOVXXX(W(1,3   ),W(1,74  ),W(1,22  ),GAL ,AMP(78  ))            
      CALL IOVXXX(W(1,3   ),W(1,74  ),W(1,26  ),GZL ,AMP(79  ))            
      CALL FVIXXX(W(1,60  ),W(1,1   ),GAL ,ZERO    ,ZERO    ,W(1,75  ))    
      CALL IOVXXX(W(1,75  ),W(1,4   ),W(1,22  ),GAL ,AMP(80  ))            
      CALL IOVXXX(W(1,75  ),W(1,4   ),W(1,26  ),GZL ,AMP(81  ))            
      CALL FVIXXX(W(1,63  ),W(1,1   ),GAL ,ZERO    ,ZERO    ,W(1,76  ))    
      CALL IOVXXX(W(1,76  ),W(1,4   ),W(1,22  ),GAL ,AMP(82  ))            
      CALL IOVXXX(W(1,76  ),W(1,4   ),W(1,26  ),GZL ,AMP(83  ))            
      CALL FVOXXX(W(1,68  ),W(1,8   ),GAL ,ZERO    ,ZERO    ,W(1,77  ))    
      CALL JIOXXX(W(1,5   ),W(1,77  ),GAL ,ZERO    ,ZERO    ,W(1,78  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,78  ),GAL ,AMP(84  ))            
      CALL JIOXXX(W(1,5   ),W(1,77  ),GZL ,ZMASS   ,ZWIDTH  ,W(1,79  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,79  ),GZL ,AMP(85  ))            
      CALL FVOXXX(W(1,68  ),W(1,14  ),GZL ,ZERO    ,ZERO    ,W(1,80  ))    
      CALL JIOXXX(W(1,5   ),W(1,80  ),GAL ,ZERO    ,ZERO    ,W(1,81  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,81  ),GAL ,AMP(86  ))            
      CALL JIOXXX(W(1,5   ),W(1,80  ),GZL ,ZMASS   ,ZWIDTH  ,W(1,82  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,82  ),GZL ,AMP(87  ))            
      CALL JIOXXX(W(1,60  ),W(1,68  ),GAL ,ZERO    ,ZERO    ,W(1,83  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,83  ),GAL ,AMP(88  ))            
      CALL JIOXXX(W(1,60  ),W(1,68  ),GZL ,ZMASS   ,ZWIDTH  ,W(1,84  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,84  ),GZL ,AMP(89  ))            
      CALL JIOXXX(W(1,63  ),W(1,68  ),GAL ,ZERO    ,ZERO    ,W(1,85  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,85  ),GAL ,AMP(90  ))            
      CALL JIOXXX(W(1,63  ),W(1,68  ),GZL ,ZMASS   ,ZWIDTH  ,W(1,86  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,86  ),GZL ,AMP(91  ))            
c      CALL HVVXXX(W(1,14  ),W(1,71  ),GZZH ,HMASS   ,HWIDTH  ,W(1,         
c     &     87  ))                                                          
c      CALL IOSXXX(W(1,7   ),W(1,6   ),W(1,87  ),GHTAU ,AMP(92  ))          
      CALL IOVXXX(W(1,7   ),W(1,39  ),W(1,69  ),GAL ,AMP(93  ))            
      CALL IOVXXX(W(1,7   ),W(1,39  ),W(1,71  ),GZL ,AMP(94  ))            
      CALL IOVXXX(W(1,7   ),W(1,42  ),W(1,69  ),GAL ,AMP(95  ))            
      CALL IOVXXX(W(1,7   ),W(1,42  ),W(1,71  ),GZL ,AMP(96  ))            
      CALL FVOXXX(W(1,6   ),W(1,69  ),GAL ,LMASS   ,ZERO    ,W(1,88  ))    
      CALL IOVXXX(W(1,7   ),W(1,88  ),W(1,8   ),GAL ,AMP(97  ))            
      CALL FVOXXX(W(1,6   ),W(1,71  ),GZL ,LMASS   ,ZERO    ,W(1,89  ))    
      CALL IOVXXX(W(1,7   ),W(1,89  ),W(1,8   ),GAL ,AMP(98  ))            
      CALL IOVXXX(W(1,7   ),W(1,88  ),W(1,14  ),GZL ,AMP(99  ))            
      CALL IOVXXX(W(1,7   ),W(1,89  ),W(1,14  ),GZL ,AMP(100 ))            
      CALL FVOXXX(W(1,2   ),W(1,54  ),GAL ,ZERO    ,ZERO    ,W(1,90  ))    
      CALL JIOXXX(W(1,52  ),W(1,6   ),GAL ,ZERO    ,ZERO    ,W(1,91  ))    
      CALL IOVXXX(W(1,3   ),W(1,90  ),W(1,91  ),GAL ,AMP(101 ))            
      CALL JIOXXX(W(1,52  ),W(1,6   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,92  ))    
      CALL IOVXXX(W(1,3   ),W(1,90  ),W(1,92  ),GZL ,AMP(102 ))            
      CALL FVOXXX(W(1,2   ),W(1,51  ),GZL ,ZERO    ,ZERO    ,W(1,93  ))    
      CALL IOVXXX(W(1,3   ),W(1,93  ),W(1,91  ),GAL ,AMP(103 ))            
      CALL IOVXXX(W(1,3   ),W(1,93  ),W(1,92  ),GZL ,AMP(104 ))            
      CALL FVIXXX(W(1,3   ),W(1,66  ),GAL ,ZERO    ,ZERO    ,W(1,94  ))    
      CALL IOVXXX(W(1,94  ),W(1,2   ),W(1,54  ),GAL ,AMP(105 ))            
      CALL FVIXXX(W(1,3   ),W(1,67  ),GZL ,ZERO    ,ZERO    ,W(1,95  ))    
      CALL IOVXXX(W(1,95  ),W(1,2   ),W(1,54  ),GAL ,AMP(106 ))            
      CALL IOVXXX(W(1,94  ),W(1,2   ),W(1,51  ),GZL ,AMP(107 ))            
      CALL IOVXXX(W(1,95  ),W(1,2   ),W(1,51  ),GZL ,AMP(108 ))            
      CALL FVIXXX(W(1,3   ),W(1,1   ),GAL ,ZERO    ,ZERO    ,W(1,96  ))    
      CALL FVIXXX(W(1,96  ),W(1,54  ),GAL ,ZERO    ,ZERO    ,W(1,97  ))    
      CALL IOVXXX(W(1,97  ),W(1,2   ),W(1,22  ),GAL ,AMP(109 ))            
      CALL IOVXXX(W(1,97  ),W(1,2   ),W(1,26  ),GZL ,AMP(110 ))            
      CALL FVIXXX(W(1,96  ),W(1,51  ),GZL ,ZERO    ,ZERO    ,W(1,98  ))    
      CALL IOVXXX(W(1,98  ),W(1,2   ),W(1,22  ),GAL ,AMP(111 ))            
      CALL IOVXXX(W(1,98  ),W(1,2   ),W(1,26  ),GZL ,AMP(112 ))            
      CALL IOVXXX(W(1,28  ),W(1,90  ),W(1,1   ),GAL ,AMP(113 ))            
      CALL IOVXXX(W(1,29  ),W(1,90  ),W(1,1   ),GAL ,AMP(114 ))            
      CALL IOVXXX(W(1,28  ),W(1,93  ),W(1,1   ),GAL ,AMP(115 ))            
      CALL IOVXXX(W(1,29  ),W(1,93  ),W(1,1   ),GAL ,AMP(116 ))            
      CALL JIOXXX(W(1,96  ),W(1,2   ),GAL ,ZERO    ,ZERO    ,W(1,99  ))    
      CALL FVIXXX(W(1,5   ),W(1,99  ),GAL ,ZERO    ,ZERO    ,W(1,100 ))    
      CALL JIOXXX(W(1,100 ),W(1,4   ),GAL ,ZERO    ,ZERO    ,W(1,101 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,101 ),GAL ,AMP(117 ))            
      CALL JIOXXX(W(1,100 ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,102 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,102 ),GZL ,AMP(118 ))            
      CALL JIOXXX(W(1,96  ),W(1,2   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,103 ))    
      CALL FVIXXX(W(1,5   ),W(1,103 ),GZL ,ZERO    ,ZERO    ,W(1,104 ))    
      CALL JIOXXX(W(1,104 ),W(1,4   ),GAL ,ZERO    ,ZERO    ,W(1,105 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,105 ),GAL ,AMP(119 ))            
      CALL JIOXXX(W(1,104 ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,106 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,106 ),GZL ,AMP(120 ))            
      CALL FVOXXX(W(1,4   ),W(1,99  ),GAL ,ZERO    ,ZERO    ,W(1,107 ))    
      CALL JIOXXX(W(1,5   ),W(1,107 ),GAL ,ZERO    ,ZERO    ,W(1,108 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,108 ),GAL ,AMP(121 ))            
      CALL JIOXXX(W(1,5   ),W(1,107 ),GZL ,ZMASS   ,ZWIDTH  ,W(1,109 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,109 ),GZL ,AMP(122 ))            
      CALL FVOXXX(W(1,4   ),W(1,103 ),GZL ,ZERO    ,ZERO    ,W(1,110 ))    
      CALL JIOXXX(W(1,5   ),W(1,110 ),GAL ,ZERO    ,ZERO    ,W(1,111 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,111 ),GAL ,AMP(123 ))            
      CALL JIOXXX(W(1,5   ),W(1,110 ),GZL ,ZMASS   ,ZWIDTH  ,W(1,112 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,112 ),GZL ,AMP(124 ))            
      CALL IOVXXX(W(1,96  ),W(1,90  ),W(1,22  ),GAL ,AMP(125 ))            
      CALL IOVXXX(W(1,96  ),W(1,90  ),W(1,26  ),GZL ,AMP(126 ))            
      CALL IOVXXX(W(1,96  ),W(1,93  ),W(1,22  ),GAL ,AMP(127 ))            
      CALL IOVXXX(W(1,96  ),W(1,93  ),W(1,26  ),GZL ,AMP(128 ))            
c      CALL HVVXXX(W(1,103 ),W(1,51  ),GZZH ,HMASS   ,HWIDTH  ,W(1,         
c     &     113 ))                                                          
c      CALL IOSXXX(W(1,7   ),W(1,6   ),W(1,113 ),GHTAU ,AMP(129 ))          
      CALL FVOXXX(W(1,6   ),W(1,99  ),GAL ,LMASS   ,ZERO    ,W(1,114 ))    
      CALL IOVXXX(W(1,7   ),W(1,114 ),W(1,54  ),GAL ,AMP(130 ))            
      CALL IOVXXX(W(1,7   ),W(1,114 ),W(1,51  ),GZL ,AMP(131 ))            
      CALL FVOXXX(W(1,6   ),W(1,103 ),GZL ,LMASS   ,ZERO    ,W(1,115 ))    
      CALL IOVXXX(W(1,7   ),W(1,115 ),W(1,54  ),GAL ,AMP(132 ))            
      CALL IOVXXX(W(1,7   ),W(1,115 ),W(1,51  ),GZL ,AMP(133 ))            
      CALL IOVXXX(W(1,7   ),W(1,58  ),W(1,99  ),GAL ,AMP(134 ))            
      CALL IOVXXX(W(1,7   ),W(1,59  ),W(1,99  ),GAL ,AMP(135 ))            
      CALL IOVXXX(W(1,7   ),W(1,58  ),W(1,103 ),GZL ,AMP(136 ))            
      CALL IOVXXX(W(1,7   ),W(1,59  ),W(1,103 ),GZL ,AMP(137 ))            
      CALL FVIXXX(W(1,3   ),W(1,54  ),GAL ,ZERO    ,ZERO    ,W(1,116 ))    
      CALL IOVXXX(W(1,116 ),W(1,2   ),W(1,91  ),GAL ,AMP(138 ))            
      CALL IOVXXX(W(1,116 ),W(1,2   ),W(1,92  ),GZL ,AMP(139 ))            
      CALL FVIXXX(W(1,3   ),W(1,51  ),GZL ,ZERO    ,ZERO    ,W(1,117 ))    
      CALL IOVXXX(W(1,117 ),W(1,2   ),W(1,91  ),GAL ,AMP(140 ))            
      CALL IOVXXX(W(1,117 ),W(1,2   ),W(1,92  ),GZL ,AMP(141 ))            
      CALL FVOXXX(W(1,2   ),W(1,66  ),GAL ,ZERO    ,ZERO    ,W(1,118 ))    
      CALL IOVXXX(W(1,3   ),W(1,118 ),W(1,54  ),GAL ,AMP(142 ))            
      CALL FVOXXX(W(1,2   ),W(1,67  ),GZL ,ZERO    ,ZERO    ,W(1,119 ))    
      CALL IOVXXX(W(1,3   ),W(1,119 ),W(1,54  ),GAL ,AMP(143 ))            
      CALL IOVXXX(W(1,3   ),W(1,118 ),W(1,51  ),GZL ,AMP(144 ))            
      CALL IOVXXX(W(1,3   ),W(1,119 ),W(1,51  ),GZL ,AMP(145 ))            
      CALL IOVXXX(W(1,116 ),W(1,24  ),W(1,1   ),GAL ,AMP(146 ))            
      CALL IOVXXX(W(1,116 ),W(1,27  ),W(1,1   ),GAL ,AMP(147 ))            
      CALL IOVXXX(W(1,117 ),W(1,24  ),W(1,1   ),GAL ,AMP(148 ))            
      CALL IOVXXX(W(1,117 ),W(1,27  ),W(1,1   ),GAL ,AMP(149 ))            
      CALL FVOXXX(W(1,2   ),W(1,1   ),GAL ,ZERO    ,ZERO    ,W(1,120 ))    
      CALL FVOXXX(W(1,120 ),W(1,54  ),GAL ,ZERO    ,ZERO    ,W(1,121 ))    
      CALL IOVXXX(W(1,3   ),W(1,121 ),W(1,22  ),GAL ,AMP(150 ))            
      CALL IOVXXX(W(1,3   ),W(1,121 ),W(1,26  ),GZL ,AMP(151 ))            
      CALL FVOXXX(W(1,120 ),W(1,51  ),GZL ,ZERO    ,ZERO    ,W(1,122 ))    
      CALL IOVXXX(W(1,3   ),W(1,122 ),W(1,22  ),GAL ,AMP(152 ))            
      CALL IOVXXX(W(1,3   ),W(1,122 ),W(1,26  ),GZL ,AMP(153 ))            
      CALL JIOXXX(W(1,3   ),W(1,120 ),GAL ,ZERO    ,ZERO    ,W(1,123 ))    
      CALL FVIXXX(W(1,5   ),W(1,123 ),GAL ,ZERO    ,ZERO    ,W(1,124 ))    
      CALL JIOXXX(W(1,124 ),W(1,4   ),GAL ,ZERO    ,ZERO    ,W(1,125 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,125 ),GAL ,AMP(154 ))            
      CALL JIOXXX(W(1,124 ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,126 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,126 ),GZL ,AMP(155 ))            
      CALL JIOXXX(W(1,3   ),W(1,120 ),GZL ,ZMASS   ,ZWIDTH  ,W(1,127 ))    
      CALL FVIXXX(W(1,5   ),W(1,127 ),GZL ,ZERO    ,ZERO    ,W(1,128 ))    
      CALL JIOXXX(W(1,128 ),W(1,4   ),GAL ,ZERO    ,ZERO    ,W(1,129 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,129 ),GAL ,AMP(156 ))            
      CALL JIOXXX(W(1,128 ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,130 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,130 ),GZL ,AMP(157 ))            
      CALL FVOXXX(W(1,4   ),W(1,123 ),GAL ,ZERO    ,ZERO    ,W(1,131 ))    
      CALL JIOXXX(W(1,5   ),W(1,131 ),GAL ,ZERO    ,ZERO    ,W(1,132 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,132 ),GAL ,AMP(158 ))            
      CALL JIOXXX(W(1,5   ),W(1,131 ),GZL ,ZMASS   ,ZWIDTH  ,W(1,133 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,133 ),GZL ,AMP(159 ))            
      CALL FVOXXX(W(1,4   ),W(1,127 ),GZL ,ZERO    ,ZERO    ,W(1,134 ))    
      CALL JIOXXX(W(1,5   ),W(1,134 ),GAL ,ZERO    ,ZERO    ,W(1,135 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,135 ),GAL ,AMP(160 ))            
      CALL JIOXXX(W(1,5   ),W(1,134 ),GZL ,ZMASS   ,ZWIDTH  ,W(1,136 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,136 ),GZL ,AMP(161 ))            
      CALL IOVXXX(W(1,116 ),W(1,120 ),W(1,22  ),GAL ,AMP(162 ))            
      CALL IOVXXX(W(1,116 ),W(1,120 ),W(1,26  ),GZL ,AMP(163 ))            
      CALL IOVXXX(W(1,117 ),W(1,120 ),W(1,22  ),GAL ,AMP(164 ))            
      CALL IOVXXX(W(1,117 ),W(1,120 ),W(1,26  ),GZL ,AMP(165 ))            
c      CALL HVVXXX(W(1,127 ),W(1,51  ),GZZH ,HMASS   ,HWIDTH  ,W(1,         
c     &     137 ))                                                          
c      CALL IOSXXX(W(1,7   ),W(1,6   ),W(1,137 ),GHTAU ,AMP(166 ))          
      CALL FVOXXX(W(1,6   ),W(1,123 ),GAL ,LMASS   ,ZERO    ,W(1,138 ))    
      CALL IOVXXX(W(1,7   ),W(1,138 ),W(1,54  ),GAL ,AMP(167 ))            
      CALL IOVXXX(W(1,7   ),W(1,138 ),W(1,51  ),GZL ,AMP(168 ))            
      CALL FVOXXX(W(1,6   ),W(1,127 ),GZL ,LMASS   ,ZERO    ,W(1,139 ))    
      CALL IOVXXX(W(1,7   ),W(1,139 ),W(1,54  ),GAL ,AMP(169 ))            
      CALL IOVXXX(W(1,7   ),W(1,139 ),W(1,51  ),GZL ,AMP(170 ))            
      CALL IOVXXX(W(1,7   ),W(1,58  ),W(1,123 ),GAL ,AMP(171 ))            
      CALL IOVXXX(W(1,7   ),W(1,59  ),W(1,123 ),GAL ,AMP(172 ))            
      CALL IOVXXX(W(1,7   ),W(1,58  ),W(1,127 ),GZL ,AMP(173 ))            
      CALL IOVXXX(W(1,7   ),W(1,59  ),W(1,127 ),GZL ,AMP(174 )) 

      zzztensor(mu) =    -AMP(   1)-AMP(   2)-AMP(   3)-AMP(   4)-AMP(   5)
     &             -AMP(   6)-AMP(   7)-AMP(   8)-AMP(   9)-AMP(  10)
     &             -AMP(  11)-AMP(  12)-AMP(  13)-AMP(  14)-AMP(  15)
     &             -AMP(  16)-AMP(  17)-AMP(  18)-AMP(  19)-AMP(  20)
     &             -AMP(  21)-AMP(  22)-AMP(  23)-AMP(  24)-AMP(  26)
     &             -AMP(  27)-AMP(  28)-AMP(  29)-AMP(  30)-AMP(  31)
     &             -AMP(  32)-AMP(  33)-AMP(  34)-AMP(  35)-AMP(  36)
     &             -AMP(  37)-AMP(  39)-AMP(  40)-AMP(  41)-AMP(  42)
     &             -AMP(  43)-AMP(  44)-AMP(  45)-AMP(  46)-AMP(  48)
     &             -AMP(  49)-AMP(  50)-AMP(  51)-AMP(  52)-AMP(  53)
     &             -AMP(  54)-AMP(  55)-AMP(  56)-AMP(  57)-AMP(  58)
     &             -AMP(  59)-AMP(  60)-AMP(  61)-AMP(  62)-AMP(  63)
     &             -AMP(  64)-AMP(  65)-AMP(  66)-AMP(  67)-AMP(  68)
     &             -AMP(  69)-AMP(  70)-AMP(  71)-AMP(  72)-AMP(  73)
     &             -AMP(  74)-AMP(  75)-AMP(  76)-AMP(  77)-AMP(  78)
     &             -AMP(  79)-AMP(  80)-AMP(  81)-AMP(  82)-AMP(  83)
     &             -AMP(  84)-AMP(  85)-AMP(  86)-AMP(  87)-AMP(  88)
     &             -AMP(  89)-AMP(  90)-AMP(  91)-AMP(  93)-AMP(  94)
     &             -AMP(  95)-AMP(  96)-AMP(  97)-AMP(  98)-AMP(  99)
     &             -AMP( 100)-AMP( 101)-AMP( 102)-AMP( 103)-AMP( 104)
     &             -AMP( 105)-AMP( 106)-AMP( 107)-AMP( 108)-AMP( 109)
     &             -AMP( 110)-AMP( 111)-AMP( 112)-AMP( 113)-AMP( 114)
     &             -AMP( 115)-AMP( 116)-AMP( 117)-AMP( 118)-AMP( 119)
     &             -AMP( 120)-AMP( 121)-AMP( 122)-AMP( 123)-AMP( 124)
     &             -AMP( 125)-AMP( 126)-AMP( 127)-AMP( 128)-AMP( 130)
     &             -AMP( 131)-AMP( 132)-AMP( 133)-AMP( 134)-AMP( 135)
     &             -AMP( 136)-AMP( 137)-AMP( 138)-AMP( 139)-AMP( 140)
     &             -AMP( 141)-AMP( 142)-AMP( 143)-AMP( 144)-AMP( 145)
     &             -AMP( 146)-AMP( 147)-AMP( 148)-AMP( 149)-AMP( 150)
     &             -AMP( 151)-AMP( 152)-AMP( 153)-AMP( 154)-AMP( 155)
     &             -AMP( 156)-AMP( 157)-AMP( 158)-AMP( 159)-AMP( 160)
     &             -AMP( 161)-AMP( 162)-AMP( 163)-AMP( 164)-AMP( 165)
     &             -AMP( 167)-AMP( 168)-AMP( 169)-AMP( 170)-AMP( 171)
     &             -AMP( 172)-AMP( 173)-AMP( 174)
c     &             -AMP(  25)-AMP(  38)-AMP(  47)-AMP(  92)-AMP( 129)!H -> tau
c     &             -AMP( 166)                                        !H -> tau
      enddo
      zzztensor(4) = dcmplx(q(0),q(3))
      zzztensor(5) = dcmplx(q(1),q(2))

      END

c ----------------------------------------------------------------------

      subroutine ztozzz(P,N,h,ZZZtensor,NW)

      IMPLICIT NONE

      DOUBLE PRECISION P(0:3,2:7)
      COMPLEX*16 ZZZtensor(0:5)
      INTEGER lsign(2:7,8),ll,mu,nu,h,N
      integer NW

      !possible lepton helicities
      data (lsign(ll,1),ll=2,7) / -1, -1, -1, -1, -1, -1/  !h=1
      data (lsign(ll,2),ll=2,7) / -1, -1,  1,  1, -1, -1/  !h=2
      data (lsign(ll,3),ll=2,7) / -1, -1, -1, -1,  1,  1/  !h=3
      data (lsign(ll,4),ll=2,7) / -1, -1,  1,  1,  1,  1/  !h=4
      data (lsign(ll,5),ll=2,7) /  1,  1, -1, -1, -1, -1/  !h=5
      data (lsign(ll,6),ll=2,7) /  1,  1,  1,  1, -1, -1/  !h=6
      data (lsign(ll,7),ll=2,7) /  1,  1, -1, -1,  1,  1/  !h=7
      data (lsign(ll,8),ll=2,7) /  1,  1,  1,  1,  1,  1/  !h=8

      call ZTOZZZ1(P,N,lsign(2,h),zzztensor(0),NW)

      ! helicity combi Nr. h is selected

      end

c-------------------------------------------------------------------

      SUBROUTINE ZTOZZZ1(P,N,lsign,zzztensor,NW)
C  
C Generated by MadGraph II Version 3.0. Updated 02/19/04                
C RETURNS AMPLITUDE SQUARED SUMMED/AVG OVER COLORS
C FOR THE POINT WITH EXTERNAL LINES W(0:6,NEXTERNAL)
C  
C FOR PROCESS : z -> e- e+ mu- mu+ ta- ta+  
C  
      IMPLICIT NONE
C  
C CONSTANTS
C  
      INTEGER    NGRAPHS 
      PARAMETER (NGRAPHS= 193) 
      INTEGER    NWAVEFUNCS
      PARAMETER (NWAVEFUNCS= 148) 
      DOUBLE PRECISION     ZERO
      PARAMETER (ZERO=0D0)
C  
C ARGUMENTS 
C  
      DOUBLE PRECISION P(0:3,2:7), Q(0:3)
      INTEGER N
      COMPLEX*16 zzztensor(0:5)
      INTEGER lsign(2:7)
      integer NW
C  
C LOCAL VARIABLES 
C  
      INTEGER I,J, mu
      COMPLEX*16 AMP(NGRAPHS)
      COMPLEX*16 W(6,NWAVEFUNCS)

c  lepton spinors and Z/A polarization vectors
#include "tensor.inc"

      logical lswitch
      parameter (lswitch=.true.)
C  
C GLOBAL VARIABLES
C  
#include "VBFNLO/utilities/coupl.inc"
C                                          
C ----------
C BEGIN CODE
C ----------
      if (lswitch) then
         do i=1,6
            w(i,2)  = zem(i,N)
            w(i,3)  = zep(i,N)
            w(i,4)  = zmm(i,N)
            w(i,5)  = zmp(i,N)
            w(i,6)  = ztm(i,N)
            w(i,7)  = ztp(i,N)
            w(i,8)  = ae(i,N)
            w(i,14) = ze(i,N)
         enddo
      endif

      do mu = 0,3
         q(mu) = p(mu,2)+p(mu,3)+p(mu,4)+p(mu,5)+p(mu,6)+p(mu,7)
      enddo

      if (.not.lswitch) then        
         CALL OXXXXX(P(0,2), ZERO , lsign(2),+1,W(1,2   ))        
         CALL IXXXXX(P(0,3), ZERO ,-lsign(3),-1,W(1,3   ))        
         CALL OXXXXX(P(0,4), ZERO , lsign(4),+1,W(1,4   ))        
         CALL IXXXXX(P(0,5), ZERO ,-lsign(5),-1,W(1,5   ))        
         CALL OXXXXX(P(0,6),LMASS , lsign(6),+1,W(1,6   ))       
         CALL IXXXXX(P(0,7),LMASS ,-lsign(7),-1,W(1,7   ))
         CALL JIOXXX(W(1,3   ),W(1,2   ),GAL ,ZERO    ,ZERO    ,W(1,8   ))  
         CALL JIOXXX(W(1,3   ),W(1,2   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,14  ))
      endif 
      if (NW.eq.1) then
      do mu = 0,3
      call TRIBOSVCARTX(Q(0), ZMASS, ZWIDTH, MU, -1, W(1,1))                   
      CALL JIOXXX(W(1,7   ),W(1,6   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,28  ))     
      CALL JIOXXX(W(1,5   ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,53  ))       
      CALL HVVXXX(W(1,53  ),W(1,14  ),GZZH ,HMASS   ,HWIDTH  ,W(1,55  ))
      CALL HVVXXX(W(1,53  ),W(1,1   ),GZZH ,HMASS   ,HWIDTH  ,W(1,60  ))     
      CALL HVVXXX(W(1,14  ),W(1,1   ),GZZH ,HMASS   ,HWIDTH  ,W(1,65  )) 
      CALL JVSXXX(W(1,53  ),W(1,65  ),GZZH ,ZMASS   ,ZWIDTH  ,W(1,66  ))
      CALL VVSXXX(W(1,28  ),W(1,1   ),W(1,55  ),GZZH ,AMP(41  ))  
      CALL VVSXXX(W(1,28  ),W(1,14  ),W(1,60  ),GZZH ,AMP(55  ))              
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,66  ),GZL ,AMP(68  ))            
      zzztensor(mu) =  -AMP(  41)-AMP(  55)-AMP(  68) !H -> ZZ contribution
      enddo

c all diagrams
      else if (NW.eq.0) then
      do mu = 0,3
      call TRIBOSVCARTX(Q(0), ZMASS, ZWIDTH, MU, -1, W(1,1))                   
      CALL FVOXXX(W(1,4   ),W(1,8   ),GAL ,ZERO    ,ZERO    ,W(1,9   ))    
      CALL JIOXXX(W(1,5   ),W(1,9   ),GAL ,ZERO    ,ZERO    ,W(1,10  ))    
      CALL FVOXXX(W(1,6   ),W(1,10  ),GAL ,LMASS   ,ZERO    ,W(1,11  ))    
      CALL IOVXXX(W(1,7   ),W(1,11  ),W(1,1   ),GZL ,AMP(1   ))            
      CALL JIOXXX(W(1,5   ),W(1,9   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,12  ))    
      CALL FVOXXX(W(1,6   ),W(1,12  ),GZL ,LMASS   ,ZERO    ,W(1,13  ))    
      CALL IOVXXX(W(1,7   ),W(1,13  ),W(1,1   ),GZL ,AMP(2   ))            
      CALL FVOXXX(W(1,4   ),W(1,14  ),GZL ,ZERO    ,ZERO    ,W(1,15  ))    
      CALL JIOXXX(W(1,5   ),W(1,15  ),GAL ,ZERO    ,ZERO    ,W(1,16  ))    
      CALL FVOXXX(W(1,6   ),W(1,16  ),GAL ,LMASS   ,ZERO    ,W(1,17  ))    
      CALL IOVXXX(W(1,7   ),W(1,17  ),W(1,1   ),GZL ,AMP(3   ))            
      CALL JIOXXX(W(1,5   ),W(1,15  ),GZL ,ZMASS   ,ZWIDTH  ,W(1,18  ))    
      CALL FVOXXX(W(1,6   ),W(1,18  ),GZL ,LMASS   ,ZERO    ,W(1,19  ))    
      CALL IOVXXX(W(1,7   ),W(1,19  ),W(1,1   ),GZL ,AMP(4   ))            
      CALL HVVXXX(W(1,12  ),W(1,1   ),GZZH ,HMASS   ,HWIDTH  ,W(1,         
     &     20  ))                                                          
      CALL IOSXXX(W(1,7   ),W(1,6   ),W(1,20  ),GHTAU ,AMP(5   ))          
      CALL HVVXXX(W(1,18  ),W(1,1   ),GZZH ,HMASS   ,HWIDTH  ,W(1,         
     &     21  ))                                                          
      CALL IOSXXX(W(1,7   ),W(1,6   ),W(1,21  ),GHTAU ,AMP(6   ))          
      CALL FVOXXX(W(1,6   ),W(1,1   ),GZL ,LMASS   ,ZERO    ,W(1,22  ))    
      CALL IOVXXX(W(1,7   ),W(1,22  ),W(1,10  ),GAL ,AMP(7   ))            
      CALL IOVXXX(W(1,7   ),W(1,22  ),W(1,12  ),GZL ,AMP(8   ))            
      CALL IOVXXX(W(1,7   ),W(1,22  ),W(1,16  ),GAL ,AMP(9   ))            
      CALL IOVXXX(W(1,7   ),W(1,22  ),W(1,18  ),GZL ,AMP(10  ))            
      CALL FVIXXX(W(1,5   ),W(1,1   ),GZL ,ZERO    ,ZERO    ,W(1,23  ))    
      CALL JIOXXX(W(1,7   ),W(1,6   ),GAL ,ZERO    ,ZERO    ,W(1,24  ))    
      CALL JIOXXX(W(1,23  ),W(1,4   ),GAL ,ZERO    ,ZERO    ,W(1,25  ))    
      CALL FVOXXX(W(1,2   ),W(1,24  ),GAL ,ZERO    ,ZERO    ,W(1,26  ))    
      CALL IOVXXX(W(1,3   ),W(1,26  ),W(1,25  ),GAL ,AMP(11  ))            
      CALL JIOXXX(W(1,23  ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,27  ))    
      CALL IOVXXX(W(1,3   ),W(1,26  ),W(1,27  ),GZL ,AMP(12  ))            
      CALL JIOXXX(W(1,7   ),W(1,6   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,28  ))    
      CALL FVOXXX(W(1,2   ),W(1,28  ),GZL ,ZERO    ,ZERO    ,W(1,29  ))    
      CALL IOVXXX(W(1,3   ),W(1,29  ),W(1,25  ),GAL ,AMP(13  ))            
      CALL IOVXXX(W(1,3   ),W(1,29  ),W(1,27  ),GZL ,AMP(14  ))            
      CALL FVIXXX(W(1,3   ),W(1,24  ),GAL ,ZERO    ,ZERO    ,W(1,30  ))    
      CALL IOVXXX(W(1,30  ),W(1,2   ),W(1,25  ),GAL ,AMP(15  ))            
      CALL IOVXXX(W(1,30  ),W(1,2   ),W(1,27  ),GZL ,AMP(16  ))            
      CALL FVIXXX(W(1,3   ),W(1,28  ),GZL ,ZERO    ,ZERO    ,W(1,31  ))    
      CALL IOVXXX(W(1,31  ),W(1,2   ),W(1,25  ),GAL ,AMP(17  ))            
      CALL IOVXXX(W(1,31  ),W(1,2   ),W(1,27  ),GZL ,AMP(18  ))            
      CALL FVIXXX(W(1,23  ),W(1,8   ),GAL ,ZERO    ,ZERO    ,W(1,32  ))    
      CALL IOVXXX(W(1,32  ),W(1,4   ),W(1,24  ),GAL ,AMP(19  ))            
      CALL IOVXXX(W(1,32  ),W(1,4   ),W(1,28  ),GZL ,AMP(20  ))            
      CALL FVIXXX(W(1,23  ),W(1,14  ),GZL ,ZERO    ,ZERO    ,W(1,33  ))    
      CALL IOVXXX(W(1,33  ),W(1,4   ),W(1,24  ),GAL ,AMP(21  ))            
      CALL IOVXXX(W(1,33  ),W(1,4   ),W(1,28  ),GZL ,AMP(22  ))            
      CALL FVOXXX(W(1,9   ),W(1,1   ),GZL ,ZERO    ,ZERO    ,W(1,34  ))    
      CALL JIOXXX(W(1,5   ),W(1,34  ),GAL ,ZERO    ,ZERO    ,W(1,35  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,35  ),GAL ,AMP(23  ))            
      CALL JIOXXX(W(1,5   ),W(1,34  ),GZL ,ZMASS   ,ZWIDTH  ,W(1,36  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,36  ),GZL ,AMP(24  ))            
      CALL FVOXXX(W(1,15  ),W(1,1   ),GZL ,ZERO    ,ZERO    ,W(1,37  ))    
      CALL JIOXXX(W(1,5   ),W(1,37  ),GAL ,ZERO    ,ZERO    ,W(1,38  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,38  ),GAL ,AMP(25  ))            
      CALL JIOXXX(W(1,5   ),W(1,37  ),GZL ,ZMASS   ,ZWIDTH  ,W(1,39  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,39  ),GZL ,AMP(26  ))            
      CALL HIOXXX(W(1,7   ),W(1,6   ),GHTAU ,HMASS   ,HWIDTH  ,W(1,        
     &     40  ))                                                          
      CALL VVSXXX(W(1,27  ),W(1,14  ),W(1,40  ),GZZH ,AMP(27  ))           
      CALL FVOXXX(W(1,6   ),W(1,8   ),GAL ,LMASS   ,ZERO    ,W(1,41  ))    
      CALL JIOXXX(W(1,7   ),W(1,41  ),GAL ,ZERO    ,ZERO    ,W(1,42  ))    
      CALL IOVXXX(W(1,23  ),W(1,4   ),W(1,42  ),GAL ,AMP(28  ))            
      CALL JIOXXX(W(1,7   ),W(1,41  ),GZL ,ZMASS   ,ZWIDTH  ,W(1,43  ))    
      CALL IOVXXX(W(1,23  ),W(1,4   ),W(1,43  ),GZL ,AMP(29  ))            
      CALL FVOXXX(W(1,6   ),W(1,14  ),GZL ,LMASS   ,ZERO    ,W(1,44  ))    
      CALL JIOXXX(W(1,7   ),W(1,44  ),GAL ,ZERO    ,ZERO    ,W(1,45  ))    
      CALL IOVXXX(W(1,23  ),W(1,4   ),W(1,45  ),GAL ,AMP(30  ))            
      CALL JIOXXX(W(1,7   ),W(1,44  ),GZL ,ZMASS   ,ZWIDTH  ,W(1,46  ))    
      CALL IOVXXX(W(1,23  ),W(1,4   ),W(1,46  ),GZL ,AMP(31  ))            
      CALL FVIXXX(W(1,7   ),W(1,8   ),GAL ,LMASS   ,ZERO    ,W(1,47  ))    
      CALL IOVXXX(W(1,47  ),W(1,6   ),W(1,25  ),GAL ,AMP(32  ))            
      CALL IOVXXX(W(1,47  ),W(1,6   ),W(1,27  ),GZL ,AMP(33  ))            
      CALL FVIXXX(W(1,7   ),W(1,14  ),GZL ,LMASS   ,ZERO    ,W(1,48  ))    
      CALL IOVXXX(W(1,48  ),W(1,6   ),W(1,25  ),GAL ,AMP(34  ))            
      CALL IOVXXX(W(1,48  ),W(1,6   ),W(1,27  ),GZL ,AMP(35  ))            
      CALL JIOXXX(W(1,23  ),W(1,9   ),GAL ,ZERO    ,ZERO    ,W(1,49  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,49  ),GAL ,AMP(36  ))            
      CALL JIOXXX(W(1,23  ),W(1,9   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,50  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,50  ),GZL ,AMP(37  ))            
      CALL JIOXXX(W(1,23  ),W(1,15  ),GAL ,ZERO    ,ZERO    ,W(1,51  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,51  ),GAL ,AMP(38  ))            
      CALL JIOXXX(W(1,23  ),W(1,15  ),GZL ,ZMASS   ,ZWIDTH  ,W(1,52  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,52  ),GZL ,AMP(39  ))            
      CALL JIOXXX(W(1,5   ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,53  ))    
      CALL FVIXXX(W(1,7   ),W(1,1   ),GZL ,LMASS   ,ZERO    ,W(1,54  ))    
      CALL HVVXXX(W(1,53  ),W(1,14  ),GZZH ,HMASS   ,HWIDTH  ,W(1,         
     &     55  ))                                                          
      CALL IOSXXX(W(1,54  ),W(1,6   ),W(1,55  ),GHTAU ,AMP(40  ))          
      CALL VVSXXX(W(1,28  ),W(1,1   ),W(1,55  ),GZZH ,AMP(41  ))           
      CALL JIOXXX(W(1,5   ),W(1,4   ),GAL ,ZERO    ,ZERO    ,W(1,56  ))    
      CALL IOVXXX(W(1,47  ),W(1,22  ),W(1,56  ),GAL ,AMP(42  ))            
      CALL IOVXXX(W(1,47  ),W(1,22  ),W(1,53  ),GZL ,AMP(43  ))            
      CALL IOVXXX(W(1,48  ),W(1,22  ),W(1,56  ),GAL ,AMP(44  ))            
      CALL IOVXXX(W(1,48  ),W(1,22  ),W(1,53  ),GZL ,AMP(45  ))            
      CALL FVIXXX(W(1,7   ),W(1,56  ),GAL ,LMASS   ,ZERO    ,W(1,57  ))    
      CALL IOVXXX(W(1,57  ),W(1,22  ),W(1,8   ),GAL ,AMP(46  ))            
      CALL FVIXXX(W(1,7   ),W(1,53  ),GZL ,LMASS   ,ZERO    ,W(1,58  ))    
      CALL IOVXXX(W(1,58  ),W(1,22  ),W(1,8   ),GAL ,AMP(47  ))            
      CALL IOVXXX(W(1,57  ),W(1,22  ),W(1,14  ),GZL ,AMP(48  ))            
      CALL IOVXXX(W(1,58  ),W(1,22  ),W(1,14  ),GZL ,AMP(49  ))            
      CALL HIOXXX(W(1,7   ),W(1,22  ),GHTAU ,HMASS   ,HWIDTH  ,W(1,        
     &     59  ))                                                          
      CALL VVSXXX(W(1,53  ),W(1,14  ),W(1,59  ),GZZH ,AMP(50  ))           
      CALL IOVXXX(W(1,54  ),W(1,41  ),W(1,56  ),GAL ,AMP(51  ))            
      CALL IOVXXX(W(1,54  ),W(1,41  ),W(1,53  ),GZL ,AMP(52  ))            
      CALL IOVXXX(W(1,54  ),W(1,44  ),W(1,56  ),GAL ,AMP(53  ))            
      CALL IOVXXX(W(1,54  ),W(1,44  ),W(1,53  ),GZL ,AMP(54  ))            
      CALL HVVXXX(W(1,53  ),W(1,1   ),GZZH ,HMASS   ,HWIDTH  ,W(1,         
     &     60  ))                                                          
      CALL VVSXXX(W(1,28  ),W(1,14  ),W(1,60  ),GZZH ,AMP(55  ))           
      CALL HIOXXX(W(1,7   ),W(1,41  ),GHTAU ,HMASS   ,HWIDTH  ,W(1,        
     &     61  ))                                                          
      CALL VVSXXX(W(1,53  ),W(1,1   ),W(1,61  ),GZZH ,AMP(56  ))           
      CALL HIOXXX(W(1,7   ),W(1,44  ),GHTAU ,HMASS   ,HWIDTH  ,W(1,        
     &     62  ))                                                          
      CALL VVSXXX(W(1,53  ),W(1,1   ),W(1,62  ),GZZH ,AMP(57  ))           
      CALL IOVXXX(W(1,57  ),W(1,41  ),W(1,1   ),GZL ,AMP(58  ))            
      CALL IOVXXX(W(1,58  ),W(1,41  ),W(1,1   ),GZL ,AMP(59  ))            
      CALL IOVXXX(W(1,57  ),W(1,44  ),W(1,1   ),GZL ,AMP(60  ))            
      CALL IOVXXX(W(1,58  ),W(1,44  ),W(1,1   ),GZL ,AMP(61  ))            
      CALL IOSXXX(W(1,47  ),W(1,6   ),W(1,60  ),GHTAU ,AMP(62  ))          
      CALL IOSXXX(W(1,48  ),W(1,6   ),W(1,60  ),GHTAU ,AMP(63  ))          
      CALL FVOXXX(W(1,6   ),W(1,56  ),GAL ,LMASS   ,ZERO    ,W(1,63  ))    
      CALL IOVXXX(W(1,54  ),W(1,63  ),W(1,8   ),GAL ,AMP(64  ))            
      CALL FVOXXX(W(1,6   ),W(1,53  ),GZL ,LMASS   ,ZERO    ,W(1,64  ))    
      CALL IOVXXX(W(1,54  ),W(1,64  ),W(1,8   ),GAL ,AMP(65  ))            
      CALL IOVXXX(W(1,54  ),W(1,63  ),W(1,14  ),GZL ,AMP(66  ))            
      CALL IOVXXX(W(1,54  ),W(1,64  ),W(1,14  ),GZL ,AMP(67  ))            
      CALL HVVXXX(W(1,14  ),W(1,1   ),GZZH ,HMASS   ,HWIDTH  ,W(1,         
     &     65  ))                                                          
      CALL JVSXXX(W(1,53  ),W(1,65  ),GZZH ,ZMASS   ,ZWIDTH  ,W(1,         
     &     66  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,66  ),GZL ,AMP(68  ))            
      CALL IOVXXX(W(1,47  ),W(1,63  ),W(1,1   ),GZL ,AMP(69  ))            
      CALL IOVXXX(W(1,47  ),W(1,64  ),W(1,1   ),GZL ,AMP(70  ))            
      CALL IOVXXX(W(1,48  ),W(1,63  ),W(1,1   ),GZL ,AMP(71  ))            
      CALL IOVXXX(W(1,48  ),W(1,64  ),W(1,1   ),GZL ,AMP(72  ))            
      CALL FSOXXX(W(1,6   ),W(1,65  ),GHTAU ,LMASS   ,ZERO    ,W(1,        
     &     67  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,67  ),W(1,56  ),GAL ,AMP(73  ))            
      CALL IOVXXX(W(1,7   ),W(1,67  ),W(1,53  ),GZL ,AMP(74  ))            
      CALL IOSXXX(W(1,7   ),W(1,63  ),W(1,65  ),GHTAU ,AMP(75  ))          
      CALL IOSXXX(W(1,7   ),W(1,64  ),W(1,65  ),GHTAU ,AMP(76  ))          
      CALL FVIXXX(W(1,5   ),W(1,8   ),GAL ,ZERO    ,ZERO    ,W(1,68  ))    
      CALL JIOXXX(W(1,68  ),W(1,4   ),GAL ,ZERO    ,ZERO    ,W(1,69  ))    
      CALL IOVXXX(W(1,54  ),W(1,6   ),W(1,69  ),GAL ,AMP(77  ))            
      CALL JIOXXX(W(1,68  ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,70  ))    
      CALL IOVXXX(W(1,54  ),W(1,6   ),W(1,70  ),GZL ,AMP(78  ))            
      CALL FVIXXX(W(1,5   ),W(1,14  ),GZL ,ZERO    ,ZERO    ,W(1,71  ))    
      CALL JIOXXX(W(1,71  ),W(1,4   ),GAL ,ZERO    ,ZERO    ,W(1,72  ))    
      CALL IOVXXX(W(1,54  ),W(1,6   ),W(1,72  ),GAL ,AMP(79  ))            
      CALL JIOXXX(W(1,71  ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,73  ))    
      CALL IOVXXX(W(1,54  ),W(1,6   ),W(1,73  ),GZL ,AMP(80  ))            
      CALL VVSXXX(W(1,1   ),W(1,70  ),W(1,40  ),GZZH ,AMP(81  ))           
      CALL VVSXXX(W(1,1   ),W(1,73  ),W(1,40  ),GZZH ,AMP(82  ))           
      CALL JIOXXX(W(1,7   ),W(1,22  ),GAL ,ZERO    ,ZERO    ,W(1,74  ))    
      CALL IOVXXX(W(1,68  ),W(1,4   ),W(1,74  ),GAL ,AMP(83  ))            
      CALL JIOXXX(W(1,7   ),W(1,22  ),GZL ,ZMASS   ,ZWIDTH  ,W(1,75  ))    
      CALL IOVXXX(W(1,68  ),W(1,4   ),W(1,75  ),GZL ,AMP(84  ))            
      CALL IOVXXX(W(1,71  ),W(1,4   ),W(1,74  ),GAL ,AMP(85  ))            
      CALL IOVXXX(W(1,71  ),W(1,4   ),W(1,75  ),GZL ,AMP(86  ))            
      CALL FVOXXX(W(1,4   ),W(1,1   ),GZL ,ZERO    ,ZERO    ,W(1,76  ))    
      CALL JIOXXX(W(1,5   ),W(1,76  ),GAL ,ZERO    ,ZERO    ,W(1,77  ))    
      CALL FVIXXX(W(1,3   ),W(1,77  ),GAL ,ZERO    ,ZERO    ,W(1,78  ))    
      CALL IOVXXX(W(1,78  ),W(1,2   ),W(1,24  ),GAL ,AMP(87  ))            
      CALL IOVXXX(W(1,78  ),W(1,2   ),W(1,28  ),GZL ,AMP(88  ))            
      CALL JIOXXX(W(1,5   ),W(1,76  ),GZL ,ZMASS   ,ZWIDTH  ,W(1,79  ))    
      CALL FVIXXX(W(1,3   ),W(1,79  ),GZL ,ZERO    ,ZERO    ,W(1,80  ))    
      CALL IOVXXX(W(1,80  ),W(1,2   ),W(1,24  ),GAL ,AMP(89  ))            
      CALL IOVXXX(W(1,80  ),W(1,2   ),W(1,28  ),GZL ,AMP(90  ))            
      CALL FVOXXX(W(1,2   ),W(1,77  ),GAL ,ZERO    ,ZERO    ,W(1,81  ))    
      CALL IOVXXX(W(1,3   ),W(1,81  ),W(1,24  ),GAL ,AMP(91  ))            
      CALL IOVXXX(W(1,3   ),W(1,81  ),W(1,28  ),GZL ,AMP(92  ))            
      CALL FVOXXX(W(1,2   ),W(1,79  ),GZL ,ZERO    ,ZERO    ,W(1,82  ))    
      CALL IOVXXX(W(1,3   ),W(1,82  ),W(1,24  ),GAL ,AMP(93  ))            
      CALL IOVXXX(W(1,3   ),W(1,82  ),W(1,28  ),GZL ,AMP(94  ))            
      CALL FVIXXX(W(1,68  ),W(1,1   ),GZL ,ZERO    ,ZERO    ,W(1,83  ))    
      CALL IOVXXX(W(1,83  ),W(1,4   ),W(1,24  ),GAL ,AMP(95  ))            
      CALL IOVXXX(W(1,83  ),W(1,4   ),W(1,28  ),GZL ,AMP(96  ))            
      CALL FVIXXX(W(1,71  ),W(1,1   ),GZL ,ZERO    ,ZERO    ,W(1,84  ))    
      CALL IOVXXX(W(1,84  ),W(1,4   ),W(1,24  ),GAL ,AMP(97  ))            
      CALL IOVXXX(W(1,84  ),W(1,4   ),W(1,28  ),GZL ,AMP(98  ))            
      CALL FVOXXX(W(1,76  ),W(1,8   ),GAL ,ZERO    ,ZERO    ,W(1,85  ))    
      CALL JIOXXX(W(1,5   ),W(1,85  ),GAL ,ZERO    ,ZERO    ,W(1,86  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,86  ),GAL ,AMP(99  ))            
      CALL JIOXXX(W(1,5   ),W(1,85  ),GZL ,ZMASS   ,ZWIDTH  ,W(1,87  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,87  ),GZL ,AMP(100 ))            
      CALL FVOXXX(W(1,76  ),W(1,14  ),GZL ,ZERO    ,ZERO    ,W(1,88  ))    
      CALL JIOXXX(W(1,5   ),W(1,88  ),GAL ,ZERO    ,ZERO    ,W(1,89  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,89  ),GAL ,AMP(101 ))            
      CALL JIOXXX(W(1,5   ),W(1,88  ),GZL ,ZMASS   ,ZWIDTH  ,W(1,90  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,90  ),GZL ,AMP(102 ))            
      CALL JIOXXX(W(1,68  ),W(1,76  ),GAL ,ZERO    ,ZERO    ,W(1,91  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,91  ),GAL ,AMP(103 ))            
      CALL JIOXXX(W(1,68  ),W(1,76  ),GZL ,ZMASS   ,ZWIDTH  ,W(1,92  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,92  ),GZL ,AMP(104 ))            
      CALL JIOXXX(W(1,71  ),W(1,76  ),GAL ,ZERO    ,ZERO    ,W(1,93  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,93  ),GAL ,AMP(105 ))            
      CALL JIOXXX(W(1,71  ),W(1,76  ),GZL ,ZMASS   ,ZWIDTH  ,W(1,94  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,94  ),GZL ,AMP(106 ))            
      CALL HVVXXX(W(1,14  ),W(1,79  ),GZZH ,HMASS   ,HWIDTH  ,W(1,         
     &     95  ))                                                          
      CALL IOSXXX(W(1,7   ),W(1,6   ),W(1,95  ),GHTAU ,AMP(107 ))          
      CALL IOVXXX(W(1,7   ),W(1,41  ),W(1,77  ),GAL ,AMP(108 ))            
      CALL IOVXXX(W(1,7   ),W(1,41  ),W(1,79  ),GZL ,AMP(109 ))            
      CALL IOVXXX(W(1,7   ),W(1,44  ),W(1,77  ),GAL ,AMP(110 ))            
      CALL IOVXXX(W(1,7   ),W(1,44  ),W(1,79  ),GZL ,AMP(111 ))            
      CALL FVOXXX(W(1,6   ),W(1,77  ),GAL ,LMASS   ,ZERO    ,W(1,96  ))    
      CALL IOVXXX(W(1,7   ),W(1,96  ),W(1,8   ),GAL ,AMP(112 ))            
      CALL FVOXXX(W(1,6   ),W(1,79  ),GZL ,LMASS   ,ZERO    ,W(1,97  ))    
      CALL IOVXXX(W(1,7   ),W(1,97  ),W(1,8   ),GAL ,AMP(113 ))            
      CALL IOVXXX(W(1,7   ),W(1,96  ),W(1,14  ),GZL ,AMP(114 ))            
      CALL IOVXXX(W(1,7   ),W(1,97  ),W(1,14  ),GZL ,AMP(115 ))            
      CALL FVOXXX(W(1,2   ),W(1,56  ),GAL ,ZERO    ,ZERO    ,W(1,98  ))    
      CALL JIOXXX(W(1,54  ),W(1,6   ),GAL ,ZERO    ,ZERO    ,W(1,99  ))    
      CALL IOVXXX(W(1,3   ),W(1,98  ),W(1,99  ),GAL ,AMP(116 ))            
      CALL JIOXXX(W(1,54  ),W(1,6   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,100 ))    
      CALL IOVXXX(W(1,3   ),W(1,98  ),W(1,100 ),GZL ,AMP(117 ))            
      CALL FVOXXX(W(1,2   ),W(1,53  ),GZL ,ZERO    ,ZERO    ,W(1,101 ))    
      CALL IOVXXX(W(1,3   ),W(1,101 ),W(1,99  ),GAL ,AMP(118 ))            
      CALL IOVXXX(W(1,3   ),W(1,101 ),W(1,100 ),GZL ,AMP(119 ))            
      CALL JVSXXX(W(1,1   ),W(1,40  ),GZZH ,ZMASS   ,ZWIDTH  ,W(1,         
     &     102 ))                                                          
      CALL IOVXXX(W(1,3   ),W(1,98  ),W(1,102 ),GZL ,AMP(120 ))            
      CALL IOVXXX(W(1,3   ),W(1,101 ),W(1,102 ),GZL ,AMP(121 ))            
      CALL FVIXXX(W(1,3   ),W(1,74  ),GAL ,ZERO    ,ZERO    ,W(1,103 ))    
      CALL IOVXXX(W(1,103 ),W(1,2   ),W(1,56  ),GAL ,AMP(122 ))            
      CALL FVIXXX(W(1,3   ),W(1,75  ),GZL ,ZERO    ,ZERO    ,W(1,104 ))    
      CALL IOVXXX(W(1,104 ),W(1,2   ),W(1,56  ),GAL ,AMP(123 ))            
      CALL IOVXXX(W(1,103 ),W(1,2   ),W(1,53  ),GZL ,AMP(124 ))            
      CALL IOVXXX(W(1,104 ),W(1,2   ),W(1,53  ),GZL ,AMP(125 ))            
      CALL FVIXXX(W(1,3   ),W(1,1   ),GZL ,ZERO    ,ZERO    ,W(1,105 ))    
      CALL FVIXXX(W(1,105 ),W(1,56  ),GAL ,ZERO    ,ZERO    ,W(1,106 ))    
      CALL IOVXXX(W(1,106 ),W(1,2   ),W(1,24  ),GAL ,AMP(126 ))            
      CALL IOVXXX(W(1,106 ),W(1,2   ),W(1,28  ),GZL ,AMP(127 ))            
      CALL FVIXXX(W(1,105 ),W(1,53  ),GZL ,ZERO    ,ZERO    ,W(1,107 ))    
      CALL IOVXXX(W(1,107 ),W(1,2   ),W(1,24  ),GAL ,AMP(128 ))            
      CALL IOVXXX(W(1,107 ),W(1,2   ),W(1,28  ),GZL ,AMP(129 ))            
      CALL IOVXXX(W(1,30  ),W(1,98  ),W(1,1   ),GZL ,AMP(130 ))            
      CALL IOVXXX(W(1,31  ),W(1,98  ),W(1,1   ),GZL ,AMP(131 ))            
      CALL IOVXXX(W(1,30  ),W(1,101 ),W(1,1   ),GZL ,AMP(132 ))            
      CALL IOVXXX(W(1,31  ),W(1,101 ),W(1,1   ),GZL ,AMP(133 ))            
      CALL JIOXXX(W(1,105 ),W(1,2   ),GAL ,ZERO    ,ZERO    ,W(1,108 ))    
      CALL FVIXXX(W(1,5   ),W(1,108 ),GAL ,ZERO    ,ZERO    ,W(1,109 ))    
      CALL JIOXXX(W(1,109 ),W(1,4   ),GAL ,ZERO    ,ZERO    ,W(1,110 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,110 ),GAL ,AMP(134 ))            
      CALL JIOXXX(W(1,109 ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,111 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,111 ),GZL ,AMP(135 ))            
      CALL JIOXXX(W(1,105 ),W(1,2   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,112 ))    
      CALL FVIXXX(W(1,5   ),W(1,112 ),GZL ,ZERO    ,ZERO    ,W(1,113 ))    
      CALL JIOXXX(W(1,113 ),W(1,4   ),GAL ,ZERO    ,ZERO    ,W(1,114 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,114 ),GAL ,AMP(136 ))            
      CALL JIOXXX(W(1,113 ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,115 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,115 ),GZL ,AMP(137 ))            
      CALL FVOXXX(W(1,4   ),W(1,108 ),GAL ,ZERO    ,ZERO    ,W(1,116 ))    
      CALL JIOXXX(W(1,5   ),W(1,116 ),GAL ,ZERO    ,ZERO    ,W(1,117 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,117 ),GAL ,AMP(138 ))            
      CALL JIOXXX(W(1,5   ),W(1,116 ),GZL ,ZMASS   ,ZWIDTH  ,W(1,118 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,118 ),GZL ,AMP(139 ))            
      CALL FVOXXX(W(1,4   ),W(1,112 ),GZL ,ZERO    ,ZERO    ,W(1,119 ))    
      CALL JIOXXX(W(1,5   ),W(1,119 ),GAL ,ZERO    ,ZERO    ,W(1,120 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,120 ),GAL ,AMP(140 ))            
      CALL JIOXXX(W(1,5   ),W(1,119 ),GZL ,ZMASS   ,ZWIDTH  ,W(1,121 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,121 ),GZL ,AMP(141 ))            
      CALL IOVXXX(W(1,105 ),W(1,98  ),W(1,24  ),GAL ,AMP(142 ))            
      CALL IOVXXX(W(1,105 ),W(1,98  ),W(1,28  ),GZL ,AMP(143 ))            
      CALL IOVXXX(W(1,105 ),W(1,101 ),W(1,24  ),GAL ,AMP(144 ))            
      CALL IOVXXX(W(1,105 ),W(1,101 ),W(1,28  ),GZL ,AMP(145 ))            
      CALL HVVXXX(W(1,112 ),W(1,53  ),GZZH ,HMASS   ,HWIDTH  ,W(1,         
     &     122 ))                                                          
      CALL IOSXXX(W(1,7   ),W(1,6   ),W(1,122 ),GHTAU ,AMP(146 ))          
      CALL FVOXXX(W(1,6   ),W(1,108 ),GAL ,LMASS   ,ZERO    ,W(1,123 ))    
      CALL IOVXXX(W(1,7   ),W(1,123 ),W(1,56  ),GAL ,AMP(147 ))            
      CALL IOVXXX(W(1,7   ),W(1,123 ),W(1,53  ),GZL ,AMP(148 ))            
      CALL FVOXXX(W(1,6   ),W(1,112 ),GZL ,LMASS   ,ZERO    ,W(1,124 ))    
      CALL IOVXXX(W(1,7   ),W(1,124 ),W(1,56  ),GAL ,AMP(149 ))            
      CALL IOVXXX(W(1,7   ),W(1,124 ),W(1,53  ),GZL ,AMP(150 ))            
      CALL IOVXXX(W(1,7   ),W(1,63  ),W(1,108 ),GAL ,AMP(151 ))            
      CALL IOVXXX(W(1,7   ),W(1,64  ),W(1,108 ),GAL ,AMP(152 ))            
      CALL IOVXXX(W(1,7   ),W(1,63  ),W(1,112 ),GZL ,AMP(153 ))            
      CALL IOVXXX(W(1,7   ),W(1,64  ),W(1,112 ),GZL ,AMP(154 ))            
      CALL FVIXXX(W(1,3   ),W(1,56  ),GAL ,ZERO    ,ZERO    ,W(1,125 ))    
      CALL IOVXXX(W(1,125 ),W(1,2   ),W(1,99  ),GAL ,AMP(155 ))            
      CALL IOVXXX(W(1,125 ),W(1,2   ),W(1,100 ),GZL ,AMP(156 ))            
      CALL FVIXXX(W(1,3   ),W(1,53  ),GZL ,ZERO    ,ZERO    ,W(1,126 ))    
      CALL IOVXXX(W(1,126 ),W(1,2   ),W(1,99  ),GAL ,AMP(157 ))            
      CALL IOVXXX(W(1,126 ),W(1,2   ),W(1,100 ),GZL ,AMP(158 ))            
      CALL IOVXXX(W(1,125 ),W(1,2   ),W(1,102 ),GZL ,AMP(159 ))            
      CALL IOVXXX(W(1,126 ),W(1,2   ),W(1,102 ),GZL ,AMP(160 ))            
      CALL FVOXXX(W(1,2   ),W(1,74  ),GAL ,ZERO    ,ZERO    ,W(1,127 ))    
      CALL IOVXXX(W(1,3   ),W(1,127 ),W(1,56  ),GAL ,AMP(161 ))            
      CALL FVOXXX(W(1,2   ),W(1,75  ),GZL ,ZERO    ,ZERO    ,W(1,128 ))    
      CALL IOVXXX(W(1,3   ),W(1,128 ),W(1,56  ),GAL ,AMP(162 ))            
      CALL IOVXXX(W(1,3   ),W(1,127 ),W(1,53  ),GZL ,AMP(163 ))            
      CALL IOVXXX(W(1,3   ),W(1,128 ),W(1,53  ),GZL ,AMP(164 ))            
      CALL IOVXXX(W(1,125 ),W(1,26  ),W(1,1   ),GZL ,AMP(165 ))            
      CALL IOVXXX(W(1,125 ),W(1,29  ),W(1,1   ),GZL ,AMP(166 ))            
      CALL IOVXXX(W(1,126 ),W(1,26  ),W(1,1   ),GZL ,AMP(167 ))            
      CALL IOVXXX(W(1,126 ),W(1,29  ),W(1,1   ),GZL ,AMP(168 ))            
      CALL FVOXXX(W(1,2   ),W(1,1   ),GZL ,ZERO    ,ZERO    ,W(1,129 ))    
      CALL FVOXXX(W(1,129 ),W(1,56  ),GAL ,ZERO    ,ZERO    ,W(1,130 ))    
      CALL IOVXXX(W(1,3   ),W(1,130 ),W(1,24  ),GAL ,AMP(169 ))            
      CALL IOVXXX(W(1,3   ),W(1,130 ),W(1,28  ),GZL ,AMP(170 ))            
      CALL FVOXXX(W(1,129 ),W(1,53  ),GZL ,ZERO    ,ZERO    ,W(1,131 ))    
      CALL IOVXXX(W(1,3   ),W(1,131 ),W(1,24  ),GAL ,AMP(171 ))            
      CALL IOVXXX(W(1,3   ),W(1,131 ),W(1,28  ),GZL ,AMP(172 ))            
      CALL JIOXXX(W(1,3   ),W(1,129 ),GAL ,ZERO    ,ZERO    ,W(1,132 ))    
      CALL FVIXXX(W(1,5   ),W(1,132 ),GAL ,ZERO    ,ZERO    ,W(1,133 ))    
      CALL JIOXXX(W(1,133 ),W(1,4   ),GAL ,ZERO    ,ZERO    ,W(1,134 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,134 ),GAL ,AMP(173 ))            
      CALL JIOXXX(W(1,133 ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,135 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,135 ),GZL ,AMP(174 ))            
      CALL JIOXXX(W(1,3   ),W(1,129 ),GZL ,ZMASS   ,ZWIDTH  ,W(1,136 ))    
      CALL FVIXXX(W(1,5   ),W(1,136 ),GZL ,ZERO    ,ZERO    ,W(1,137 ))    
      CALL JIOXXX(W(1,137 ),W(1,4   ),GAL ,ZERO    ,ZERO    ,W(1,138 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,138 ),GAL ,AMP(175 ))            
      CALL JIOXXX(W(1,137 ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,139 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,139 ),GZL ,AMP(176 ))            
      CALL FVOXXX(W(1,4   ),W(1,132 ),GAL ,ZERO    ,ZERO    ,W(1,140 ))    
      CALL JIOXXX(W(1,5   ),W(1,140 ),GAL ,ZERO    ,ZERO    ,W(1,141 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,141 ),GAL ,AMP(177 ))            
      CALL JIOXXX(W(1,5   ),W(1,140 ),GZL ,ZMASS   ,ZWIDTH  ,W(1,142 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,142 ),GZL ,AMP(178 ))            
      CALL FVOXXX(W(1,4   ),W(1,136 ),GZL ,ZERO    ,ZERO    ,W(1,143 ))    
      CALL JIOXXX(W(1,5   ),W(1,143 ),GAL ,ZERO    ,ZERO    ,W(1,144 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,144 ),GAL ,AMP(179 ))            
      CALL JIOXXX(W(1,5   ),W(1,143 ),GZL ,ZMASS   ,ZWIDTH  ,W(1,145 ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,145 ),GZL ,AMP(180 ))            
      CALL IOVXXX(W(1,125 ),W(1,129 ),W(1,24  ),GAL ,AMP(181 ))            
      CALL IOVXXX(W(1,125 ),W(1,129 ),W(1,28  ),GZL ,AMP(182 ))            
      CALL IOVXXX(W(1,126 ),W(1,129 ),W(1,24  ),GAL ,AMP(183 ))            
      CALL IOVXXX(W(1,126 ),W(1,129 ),W(1,28  ),GZL ,AMP(184 ))            
      CALL HVVXXX(W(1,136 ),W(1,53  ),GZZH ,HMASS   ,HWIDTH  ,W(1,         
     &     146 ))                                                          
      CALL IOSXXX(W(1,7   ),W(1,6   ),W(1,146 ),GHTAU ,AMP(185 ))          
      CALL FVOXXX(W(1,6   ),W(1,132 ),GAL ,LMASS   ,ZERO    ,W(1,147 ))    
      CALL IOVXXX(W(1,7   ),W(1,147 ),W(1,56  ),GAL ,AMP(186 ))            
      CALL IOVXXX(W(1,7   ),W(1,147 ),W(1,53  ),GZL ,AMP(187 ))            
      CALL FVOXXX(W(1,6   ),W(1,136 ),GZL ,LMASS   ,ZERO    ,W(1,148 ))    
      CALL IOVXXX(W(1,7   ),W(1,148 ),W(1,56  ),GAL ,AMP(188 ))            
      CALL IOVXXX(W(1,7   ),W(1,148 ),W(1,53  ),GZL ,AMP(189 ))            
      CALL IOVXXX(W(1,7   ),W(1,63  ),W(1,132 ),GAL ,AMP(190 ))            
      CALL IOVXXX(W(1,7   ),W(1,64  ),W(1,132 ),GAL ,AMP(191 ))            
      CALL IOVXXX(W(1,7   ),W(1,63  ),W(1,136 ),GZL ,AMP(192 ))            
      CALL IOVXXX(W(1,7   ),W(1,64  ),W(1,136 ),GZL ,AMP(193 )) 
      zzztensor(mu) =    -AMP(   1)-AMP(   2)-AMP(   3)-AMP(   4)-AMP(   7)!non
     &             -AMP(   8)-AMP(   9)-AMP(  10)-AMP(  11)-AMP(  12)!resonant
     &             -AMP(  13)-AMP(  14)-AMP(  15)-AMP(  16)-AMP(  17)!
     &             -AMP(  18)-AMP(  19)-AMP(  20)-AMP(  21)-AMP(  22)!
     &             -AMP(  23)-AMP(  24)-AMP(  25)-AMP(  26)-AMP(  28)!non
     &             -AMP(  29)-AMP(  30)-AMP(  31)-AMP(  32)-AMP(  33)!resonant
     &             -AMP(  34)-AMP(  35)-AMP(  36)-AMP(  37)-AMP(  38)!
     &             -AMP(  39)-AMP(  42)-AMP(  43)-AMP(  44)-AMP(  45)!
     &             -AMP(  46)-AMP(  47)-AMP(  48)-AMP(  49)-AMP(  51)!non
     &             -AMP(  52)-AMP(  53)-AMP(  54)-AMP(  58)-AMP(  59)!resonant
     &             -AMP(  60)-AMP(  61)-AMP(  64)-AMP(  65)-AMP(  66)!
     &             -AMP(  67)-AMP(  69)-AMP(  70)-AMP(  71)-AMP(  72)!
     &             -AMP(  77)-AMP(  78)-AMP(  79)-AMP(  80)-AMP(  83)!non
     &             -AMP(  84)-AMP(  85)-AMP(  86)-AMP(  87)-AMP(  88)!resonant
     &             -AMP(  89)-AMP(  90)-AMP(  91)-AMP(  92)-AMP(  93)!
     &             -AMP(  94)-AMP(  95)-AMP(  96)-AMP(  97)-AMP(  98)!
     &             -AMP(  99)-AMP( 100)-AMP( 101)-AMP( 102)-AMP( 103)!non
     &             -AMP( 104)-AMP( 105)-AMP( 106)-AMP( 108)-AMP( 109)!resonant
     &             -AMP( 110)-AMP( 111)-AMP( 112)-AMP( 113)-AMP( 114)!
     &             -AMP( 115)-AMP( 116)-AMP( 117)-AMP( 118)-AMP( 119)!
     &             -AMP( 122)-AMP( 123)-AMP( 124)-AMP( 125)-AMP( 126)!non
     &             -AMP( 127)-AMP( 128)-AMP( 129)-AMP( 130)-AMP( 131)!resonant
     &             -AMP( 132)-AMP( 133)-AMP( 134)-AMP( 135)-AMP( 136)!
     &             -AMP( 137)-AMP( 138)-AMP( 139)-AMP( 140)-AMP( 141)!
     &             -AMP( 142)-AMP( 143)-AMP( 144)-AMP( 145)-AMP( 147)!non
     &             -AMP( 148)-AMP( 149)-AMP( 150)-AMP( 151)-AMP( 152)!resonant
     &             -AMP( 153)-AMP( 154)-AMP( 155)-AMP( 156)-AMP( 157)!
     &             -AMP( 158)-AMP( 161)-AMP( 162)-AMP( 163)-AMP( 164)!
     &             -AMP( 165)-AMP( 166)-AMP( 167)-AMP( 168)-AMP( 169)!non
     &             -AMP( 170)-AMP( 171)-AMP( 172)-AMP( 173)-AMP( 174)!resonant
     &             -AMP( 175)-AMP( 176)-AMP( 177)-AMP( 178)-AMP( 179)!
     &             -AMP( 180)-AMP( 181)-AMP( 182)-AMP( 183)-AMP( 184)!
     &             -AMP( 186)-AMP( 187)-AMP( 188)-AMP( 189)-AMP( 190)!non
     &             -AMP( 191)-AMP( 192)-AMP( 193)                    !resonant
     &             -AMP(  41)-AMP(  55)-AMP(  68)      !H -> ZZ
c     &             -AMP(   5)-AMP(   6)-AMP(  27)-AMP(  40)-AMP(  50)!H -> tau
c     &             -AMP(  56)-AMP(  57)-AMP(  62)-AMP(  63)-AMP(  73)!H -> tau
c     &             -AMP(  74)-AMP(  75)-AMP(  76)-AMP(  81)-AMP(  82)!H -> tau
c     &             -AMP( 107)-AMP( 120)-AMP( 121)-AMP( 146)-AMP( 159)!H -> tau
c     &             -AMP( 160)-AMP( 185)                              !H -> tau
      enddo
      endif !NW
      zzztensor(4) = dcmplx(q(0),q(3))
      zzztensor(5) = dcmplx(q(1),q(2))

      END

c ----------------------------------------------------------------------

      subroutine ztozzzHiggs(P,N,h,ZZZtensor1,ZZZtensor2,ZZZtensor3,NW)

      IMPLICIT NONE

      DOUBLE PRECISION P(0:3,2:7)
      COMPLEX*16 ZZZtensor1(0:5),ZZZtensor2(0:5),ZZZtensor3(0:5)
      INTEGER lsign(2:7,8),ll,mu,nu,h,N
      integer NW

      !possible lepton helicities
      data (lsign(ll,1),ll=2,7) / -1, -1, -1, -1, -1, -1/  !h=1
      data (lsign(ll,2),ll=2,7) / -1, -1,  1,  1, -1, -1/  !h=2
      data (lsign(ll,3),ll=2,7) / -1, -1, -1, -1,  1,  1/  !h=3
      data (lsign(ll,4),ll=2,7) / -1, -1,  1,  1,  1,  1/  !h=4
      data (lsign(ll,5),ll=2,7) /  1,  1, -1, -1, -1, -1/  !h=5
      data (lsign(ll,6),ll=2,7) /  1,  1,  1,  1, -1, -1/  !h=6
      data (lsign(ll,7),ll=2,7) /  1,  1, -1, -1,  1,  1/  !h=7
      data (lsign(ll,8),ll=2,7) /  1,  1,  1,  1,  1,  1/  !h=8

      call ZTOZZZHiggs1(P,N,lsign(2,h),zzztensor1(0),zzztensor2(0),
     1                zzztensor3(0),NW)

      ! helicity combi Nr. h is selected

      end

c-------------------------------------------------------------------

      SUBROUTINE ZTOZZZHiggs1(P,N,lsign,zzztensor1,zzztensor2,
     1                zzztensor3,NW)
C  
C Generated by MadGraph II Version 3.0. Updated 02/19/04                
C RETURNS AMPLITUDE SQUARED SUMMED/AVG OVER COLORS
C FOR THE POINT WITH EXTERNAL LINES W(0:6,NEXTERNAL)
C  
C FOR PROCESS : z -> e- e+ mu- mu+ ta- ta+  
C  
      IMPLICIT NONE
C  
C CONSTANTS
C  
      INTEGER    NGRAPHS 
      PARAMETER (NGRAPHS= 193) 
      INTEGER    NWAVEFUNCS
      PARAMETER (NWAVEFUNCS= 148) 
      DOUBLE PRECISION     ZERO
      PARAMETER (ZERO=0D0)
C  
C ARGUMENTS 
C  
      DOUBLE PRECISION P(0:3,2:7), Q(0:3)
      INTEGER N
      COMPLEX*16 zzztensor1(0:5), zzztensor2(0:5), zzztensor3(0:5)
      INTEGER lsign(2:7)
      integer NW
C  
C LOCAL VARIABLES 
C  
      INTEGER I,J, mu
      COMPLEX*16 AMP(NGRAPHS)
      COMPLEX*16 W(6,NWAVEFUNCS)

c  lepton spinors and Z/A polarization vectors
#include "tensor.inc"

      logical lswitch
      parameter (lswitch=.true.)
C  
C GLOBAL VARIABLES
C  
#include "VBFNLO/utilities/coupl.inc"
C                                          
C ----------
C BEGIN CODE
C ----------
      if (lswitch) then
         do i=1,6
            w(i,2)  = zem(i,N)
            w(i,3)  = zep(i,N)
            w(i,4)  = zmm(i,N)
            w(i,5)  = zmp(i,N)
            w(i,6)  = ztm(i,N)
            w(i,7)  = ztp(i,N)
            w(i,8)  = ae(i,N)
            w(i,14) = ze(i,N)
         enddo
      endif

      do mu = 0,3
         q(mu) = p(mu,2)+p(mu,3)+p(mu,4)+p(mu,5)+p(mu,6)+p(mu,7)
      enddo

      if (.not.lswitch) then        
         CALL OXXXXX(P(0,2), ZERO , lsign(2),+1,W(1,2   ))        
         CALL IXXXXX(P(0,3), ZERO ,-lsign(3),-1,W(1,3   ))        
         CALL OXXXXX(P(0,4), ZERO , lsign(4),+1,W(1,4   ))        
         CALL IXXXXX(P(0,5), ZERO ,-lsign(5),-1,W(1,5   ))        
         CALL OXXXXX(P(0,6),LMASS , lsign(6),+1,W(1,6   ))       
         CALL IXXXXX(P(0,7),LMASS ,-lsign(7),-1,W(1,7   ))
         CALL JIOXXX(W(1,3   ),W(1,2   ),GAL ,ZERO    ,ZERO    ,W(1,8   ))  
         CALL JIOXXX(W(1,3   ),W(1,2   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,14  ))
      endif 

      do mu = 0,3
      call TRIBOSVCARTX(Q(0), ZMASS, ZWIDTH, MU, -1, W(1,1))           
      CALL JIOXXX(W(1,7   ),W(1,6   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,28  ))    
      CALL JIOXXX(W(1,5   ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,53  )) 
      CALL HVVXXX(W(1,53  ),W(1,14  ),GZZH ,HMASS   ,HWIDTH  ,W(1,55  ))
      CALL HVVXXX(W(1,53  ),W(1,1   ),GZZH ,HMASS   ,HWIDTH  ,W(1,60  ))   
      CALL HVVXXX(W(1,14  ),W(1,1   ),GZZH ,HMASS   ,HWIDTH  ,W(1,65  )) 
      CALL JVSXXX(W(1,53  ),W(1,65  ),GZZH ,ZMASS   ,ZWIDTH  ,W(1,66  ))
      CALL VVSXXX(W(1,28  ),W(1,1   ),W(1,55  ),GZZH ,AMP(41  ))  
      CALL VVSXXX(W(1,28  ),W(1,14  ),W(1,60  ),GZZH ,AMP(55  ))              
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,66  ),GZL ,AMP(68  ))            
      zzztensor1(mu) =  -AMP(  41) !H -> Z1Z2 contribution
      zzztensor2(mu) =  -AMP(  55) !H -> Z1Z3 contribution
      zzztensor3(mu) =  -AMP(  68) !H -> Z2Z3 contribution
      enddo

      zzztensor1(4) = dcmplx(q(0),q(3))
      zzztensor1(5) = dcmplx(q(1),q(2))
      zzztensor2(4) = dcmplx(q(0),q(3))
      zzztensor2(5) = dcmplx(q(1),q(2))
      zzztensor3(4) = dcmplx(q(0),q(3))
      zzztensor3(5) = dcmplx(q(1),q(2))


      END
