c Francisco Campanario
c Date 2012 05 04
c francam@particle.uni-kalrsruhe.de

      subroutine Init_Instabilities(ps_number)
      implicit none
c include global variables via include-files, e.g. "procID"

#include "VBFNLO/utilities/global.inc"
#include "VBFNLO/utilities/lha.inc"
#include "VBFNLO/utilities/tau_hel.inc"
#include "VBFNLO/utilities/process.inc"
#include "VBFNLO/utilities/scales.inc"

      integer ps_number
      integer iteration, seed
      integer*8 Ncall, i, two
      parameter (two = 2)
      common/Ncall1/Ncall,iteration
      integer gnlo
      common /nlovariable/ gnlo

      virt_b(ps_number)=0d0
      e_virt_b(ps_number)=0d0
      box_v(ps_number)=0d0
      e_box_v(ps_number)=0d0
      pent_v(ps_number)=0d0
      e_pent_v(ps_number)=0d0
      hex_v(ps_number)=0d0
      e_hex_v(ps_number)=0d0
      box2_v(ps_number)=0d0
      e_box2_v(ps_number)=0d0
     
      boxcountps(ps_number)=0
      boxcount2ps(ps_number)=0
      box2countps(ps_number)=0
      box2count2ps(ps_number)=0
      pentcountps(ps_number)=0
      pentcount2ps(ps_number)=0
      hexcountps(ps_number)=0
      hexcount2ps(ps_number)=0
      

      end



********************************************************************************
********************************************************************************

      subroutine Instabilities(ps_number)

      implicit none

c include global variables via include-files, e.g. "procID"
#include "VBFNLO/utilities/global.inc"
#include "VBFNLO/utilities/lha.inc"
#include "VBFNLO/utilities/tau_hel.inc"
#include "VBFNLO/utilities/process.inc"
#include "VBFNLO/utilities/scales.inc"

      integer ps_number
      integer iteration, seed
      integer*8 Ncall, i, two
      parameter (two = 2)
      common/Ncall1/Ncall,iteration
      integer gnlo
      common /nlovariable/ gnlo

      Select Case(procID)
      CASE(WPZA,WMZA,WPAA,WMAA,ZAA,AAA,WPAAj,WMAAj)

         If(gnlo.eq.2) then

            print *," Box instabilites", boxcountps(ps_number)
            print *,"          total calls", 
     &           boxcountps(ps_number)+boxcount2ps(ps_number)
            if (Dble(boxcountps(ps_number)+boxcount2ps(ps_number)).
     &           ne.0d0) then
               print *,"          instabilities [%]", 
     &              100d0*boxcountps(ps_number)
     &              /Dble(boxcountps(ps_number)+boxcount2ps(ps_number))
            else
               print *,"          instabilities [%]", 0d0
            endif

         elseIf(gnlo.eq.3) then
            print *," Pentagon instabilites", pentcountps(ps_number)
            print *,"          total calls", 
     &           pentcountps(ps_number)+pentcount2ps(ps_number)
            if (Dble(pentcountps(ps_number)+
     &           pentcount2ps(ps_number)).ne.0d0) then
               print *,"          instabilities [%]", 
     &              100d0*pentcountps(ps_number)
     &              /Dble(pentcountps(ps_number)+pentcount2ps(ps_number))
            else
               print *,"          instabilities [%]", 0d0
            endif
            
         elseIf(gnlo.eq.4) then
            print *," Hexagon instabilites", Hexcountps(ps_number)
            print *,"          total calls", 
     &           hexcountps(ps_number)+hexcount2ps(ps_number)
            if (Dble(hexcountps(ps_number)+
     &           hexcount2ps(ps_number)).ne.0d0) then
               print *,"          instabilities [%]", 
     &              100d0*hexcountps(ps_number)
     &              /Dble(hexcountps(ps_number)+hexcount2ps(ps_number))
            else
               print *,"          instabilities [%]", 0d0
            endif
            
         elseIf(gnlo.eq.5) then
                        
            print *," Box2 instabilites", box2countps(ps_number)
            print *,"          total calls", 
     &           box2countps(ps_number)+box2count2ps(ps_number)
            if (Dble(box2countps(ps_number)+
     &           box2count2ps(ps_number)).ne.0d0) then
               print *,"          instabilities [%]", 
     &              100d0*box2countps(ps_number)
     &              /Dble(box2countps(ps_number)+box2count2ps(ps_number))
            else
               print *,"          instabilities [%]", 0d0
            endif
            
         endif

      END SELECT


      END



********************************************************************************
********************************************************************************
      
      subroutine Final_Instabilities

      implicit none

c include global variables via include-files, e.g. "procID"
#include "VBFNLO/utilities/global.inc"
#include "VBFNLO/utilities/lha.inc"
#include "VBFNLO/utilities/tau_hel.inc"
#include "VBFNLO/utilities/process.inc"
#include "VBFNLO/utilities/scales.inc"

      Select Case(procID)
      CASE(WPZA,WMZA,WPAA,WMAA,ZAA,AAA,WPAAj,WMAAj)

         print *," "
         print *," Box instabilites", boxcountm
         print *,"          total calls", 
     &        boxcountm+boxcount2m
         if (Dble(boxcountm+boxcount2m).ne.0d0) then
            print *,"          instabilities [%]", 
     &           100d0*boxcountm
     &           /Dble(boxcountm+boxcount2m)
         else
            print *,"          instabilities [%]", 0d0
         endif
         

         print *," FBox instabilites", box2countm
         print *,"          total calls", 
     &        box2countm+box2count2m
         if (Dble(box2countm+box2count2m).ne.0d0) then
            print *,"          instabilities [%]", 
     &           100d0*box2countm
     &           /Dble(box2countm+box2count2m)
         else
            print *,"          instabilities [%]", 0d0
         endif
         
         
         print *," Pentagon instabilites", pentcountm
         print *,"          total calls", 
     &        pentcountm+pentcount2m
         if (Dble(pentcountm+pentcount2m).ne.0d0) then
            print *,"          instabilities [%]", 
     &           100d0*pentcountm/Dble(pentcountm+pentcount2m)
         else
            print *,"          instabilities [%]", 0d0
         endif
         
         
         print *," Hexagon instabilites", Hexcountm
         print *,"          total calls", 
     &        hexcountm+hexcount2m
         if (Dble(hexcountm+hexcount2m).ne.0d0) then
            print *,"          instabilities [%]", 
     &           100d0*hexcountm
     &           /Dble(hexcountm+hexcount2m)
         else
            print *,"          instabilities [%]", 0d0
         endif
         
      END SELECT
      return

      end



********************************************************************************
********************************************************************************
      
      subroutine Final_Printing

      implicit none

c include global variables via include-files, e.g. "procID"
#include "VBFNLO/utilities/global.inc"
#include "VBFNLO/utilities/lha.inc"
#include "VBFNLO/utilities/tau_hel.inc"
#include "VBFNLO/utilities/process.inc"
#include "VBFNLO/utilities/scales.inc"

      integer ps_number
      real*8 ps_xsec(5), ps_sdev(5),sub_xsec(5), sub_sdev(5)
      common/finalPr/ ps_xsec, ps_sdev,sub_xsec, sub_sdev


      write(*,*) ""

      if (PS_Loops .gt. 1) then
         write(*,*) ""
         write(*,*) "LO for different PHASESPACE:"
         do ps_number =1,PS_Loops
            write(*,*)  lo_r(ps_number)," +- " ,e_lo_r(ps_number) ," fb", 
     &           100d0*sqrt(e_lo_r(ps_number)**2)/lo_r(ps_number)
         enddo
      endif

      if (PS_Loops .gt. 1 .and. doNLO) then
         if (NLO_loops .ge. 1) then
            write(*,*)" "
            write(*,*)" "
            write(*,*)"VIRTUAL CONTRIBUTIONS for different PHASESPACE:"


            write(*,*) " borntype for different PHASESPACE:"
            do ps_number =1,PS_Loops
               write(*,*)  virt_b(ps_number)," +- " ,e_virt_b(ps_number) ,
     &              " fb", 100d0*sqrt(e_virt_b(ps_number)**2)/virt_b(ps_number)
            enddo
         end if
         
         if (NLO_loops .ge. 2) then
            write(*,*) " boxes for different PHASESPACE:"     
            do ps_number =1,PS_Loops
               write(*,*)  box_v(ps_number)," +- " ,e_box_v(ps_number) ,
     &              " fb", 100d0*sqrt(e_box_v(ps_number)**2)/
     &              box_v(ps_number)
            enddo
         end if
         
         if (NLO_loops .ge. 5) then
            write(*,*) " boxes2 for different PHASESPACE:"     
            do ps_number =1,PS_Loops
               write(*,*)  box2_v(ps_number)," +- " ,e_box2_v(ps_number) ,
     &              " fb", 
     &              100d0*sqrt(e_box2_v(ps_number)**2)/box2_v(ps_number)
            enddo
         end if
         
         if (NLO_loops .ge. 3) then
            write(*,*) "pentagons for different PHASESPACE:"
            do ps_number =1,PS_Loops
               write(*,*)  pent_v(ps_number)," +- " ,e_pent_v(ps_number) ,
     &              " fb", 
     &              100d0*sqrt(e_pent_v(ps_number)**2)/pent_v(ps_number)
            enddo
         end if
         
         if (NLO_loops .ge. 4) then
            write(*,*) "hexagons for different PHASESPACE:"
            do ps_number =1,PS_Loops
               write(*,*)  hex_v(ps_number)," +- " ,e_hex_v(ps_number) ,
     &              " fb", 
     &              100d0*sqrt(e_hex_v(ps_number)**2)/hex_v(ps_number)
            enddo
         end if
      end if
      

c      write(*,*) "K-Factor",  (ps_xsec(2)+ps_xsec(3))/ps_xsec(1)
c      write(*,*) "K-Factor-virtual",  (ps_xsec(2))/ps_xsec(1)
c      write(*,*) ""
      
** NOW THE TOTAL FOR EACH CONTRIBUTION  
      if (NLO_loops .ge. 1 .and. doNLO) then
         write(*,*)"  "
         write(*,*) "TOTAL VIRTUAL CONTRIBUTIONS:"
         write(*,*) "TOTAL borntype:"
         do ps_number =2,PS_Loops
            virt_b(1)=virt_b(1)+virt_b(ps_number)
         enddo
         virt_b(2) =0
         do ps_number =1,PS_Loops
            virt_b(2)=virt_b(2)+e_virt_b(ps_number)**2
         enddo
         write(*,*)  virt_b(1), sqrt(virt_b(2)),
     &        100d0*Sqrt(virt_b(2))/(virt_b(1))
      end if
         
      if (NLO_loops .ge. 2 .and. doNLO) then
         write(*,*) "TOTAL boxes:"
         do ps_number =2,PS_Loops
            box_v(1)=box_v(1)+box_v(ps_number)
         enddo
         box_v(2) =0
         do ps_number =1,PS_Loops
            box_v(2)=box_v(2)+e_box_v(ps_number)**2
         enddo
         write(*,*)  box_v(1),Sqrt(box_v(2)),
     &        100d0*Sqrt(box_v(2))/(box_v(1))
      end if
         
      if (NLO_loops .ge. 5 .and. doNLO) then
         write(*,*) "TOTAL boxes2:"
         do ps_number =2,PS_Loops
            box2_v(1)=box2_v(1)+box2_v(ps_number)
         enddo
         box2_v(2) =0
         do ps_number =1,PS_Loops
            box2_v(2)=box2_v(2)+e_box2_v(ps_number)**2
         enddo
         write(*,*)  box2_v(1),Sqrt(box2_v(2)),
     &        100d0*Sqrt(box2_v(2))/(box2_v(1))
      end if

      if (NLO_loops .ge. 3 .and. doNLO) then
         write(*,*) "TOTAL pentagons:"
         do ps_number =2,PS_Loops
            pent_v(1)=pent_v(1)+pent_v(ps_number)
         enddo
         pent_v(2) =0
         do ps_number =1,PS_Loops
            pent_v(2)=pent_v(2)+e_pent_v(ps_number)**2
         enddo
         write(*,*)  pent_v(1) ,Sqrt(pent_v(2)),
     &        100d0*Sqrt(pent_v(2))/(pent_v(1))
      end if
      
      if (NLO_loops .ge. 4 .and. doNLO) then
         write(*,*) "TOTAL hexagons:"
         do ps_number =2,PS_Loops
            hex_v(1)=hex_v(1)+hex_v(ps_number)
         enddo
         hex_v(2) =0
         do ps_number =1,PS_Loops
            hex_v(2)=hex_v(2)+e_hex_v(ps_number)**2
         enddo
         write(*,*)  hex_v(1) ,Sqrt(hex_v(2)),
     &        100d0*Sqrt(hex_v(2))/(hex_v(1))
      end if


c      if (NLO_loops .gt. 1 .and. doNLO) then
c         print*,""
c         print*, "TOTAL VIRTUAL",virt_b(1) + box_v(1)+pent_v(1)+hex_v(1)+ 
c     &        box2_v(1)
         
c         print*, "check:", virt_b(1) + box_v(1)+pent_v(1)+hex_v(1)+ 
c     &        box2_v(1) +ps_xsec(3)-(ps_xsec(2)+ps_xsec(3))
c      end if


* Real emission:      
      if (PS_loops .gt. 1 .and. doNLO) then
         write(*,*) " "
         write(*,*) " "
         write(*,*) " REAL EMISSION for different PHASESPACE:"
         do ps_number =1,PS_Loops
            write(*,*)   Re_nlo(ps_number)," +- " , e_Re_nlo(ps_number) ,
     &           " fb", 
     &           100d0*e_ Re_nlo(ps_number)/Re_nlo(ps_number)
         enddo
      end if

      

      return
      end
