****************************************************************************
*     This file contains routines for the unweighting of events.
****************************************************************************

****************************************************************************
      Subroutine ResetWeights(ps_number)
****************************************************************************
*     call this subroutine at the beginning of each iteration
****************************************************************************
      implicit none
      integer nevraw,nevovr,prenevacc
      logical lwri
      common/events/nevraw,nevovr,prenevacc,lwri
      integer ps_number

#include "lha.inc"

      if (ps_number.eq.1) maxweight=0d0         ! for multi-PS: maxweight of subsequent PS should not be smaller
      nevraw=0
      nevovr=0
      nevacc=0
      nevall=0
      prenevacc=0
      prenevunw=0
      lwri=.false.

      return
      end

****************************************************************************
      Subroutine ReweightingInfo(unweighted)
****************************************************************************
      implicit none
      integer nevraw,nevovr,prenevacc
      logical lwri, unweighted
      common/events/nevraw,nevovr,prenevacc,lwri

#include "lha.inc"

      if (unweighted) then

            if(lha.or.hepmc)then
               if(unweighting)then
                  print*,"maximal weight",wtmax*maxweight_first
                  print*,"number of unweighted events =",nevacc
               else
                  print*,"maximal weight",wtmax
               endif
            endif
            print*,""

      else

            print*,"number of events after cuts =",nevraw
            print*,"number of events used to calculate pre-maximal weight =",prenevunw
            print*,"pre-maximal weight",maxweight
            print*,""

      endif
      
      return
      end


****************************************************************************
      Subroutine Reweight(evnweight,i,Ncall,ps_number)
****************************************************************************

      implicit none
      real*8 evnweight,RandomNumber,rn
      external RandomNumber
      integer nevraw,nevovr,prenevacc
      logical lwri
      common/events/nevraw,nevovr,prenevacc,lwri
      integer*8 Ncall, i
      integer ps_number

#include "lha.inc"

      nevraw=nevraw+1

      if(.not.lwri) then
         prenevunw = prenevunw + 1
         if(eventweight.gt.maxweight) then 
            maxweight=eventweight
         endif
c         print*, DBLE(i)/DBLE(Ncall), premaxw_frac
         if( DBLE(i)/DBLE(Ncall) .ge. premaxw_frac ) then                              
            lwri=.true.
            if (ps_number.eq.1) maxweight_first = maxweight
            maxweight_ratio = maxweight / maxweight_first
         endif
      endif
      if(unweighting)then
         if(lwri)then
            if(eventweight.gt.maxweight)then
               nevovr=nevovr+1
               evnweight = eventweight/maxweight_first
            else
               rn=RandomNumber()
               if(rn*maxweight.lt.eventweight) then ! event is to be kept
                  prenevacc=prenevacc+1
                  evnweight=maxweight_ratio
               else
                  evnweight=0d0
               endif
            endif
         else
            evnweight=0d0
         endif
      endif
      return
      end


