c Francisco Campanario
c
c subroutine statistics_proc
c subroutine statistics_proc_NLO
c subroutine Instabilities

      subroutine statistics_proc(ps_number)
      implicit none
c include global variables via include-files, e.g. "procID"
#include "VBFNLO/utilities/global.inc"
#include "VBFNLO/utilities/lha.inc"
#include "VBFNLO/utilities/tau_hel.inc"
#include "VBFNLO/utilities/process.inc"
#include "VBFNLO/utilities/scales.inc"

c     variables for the integration loops
      integer iteration, seed
      integer*8 Ncall, i, two
      integer ps_number
      parameter (two = 2)
      common/Ncall1/Ncall,iteration


      Select Case(procID)
      CASE(WPZA, WMZA)
         if (ps_number.eq.1) then
            Ncall = two**( N_points(0) - N_iterations1 + iteration )
         else
            Ncall = two**( N_points(0) + 1 - N_iterations1 + iteration )
         endif
      CASE(WPAA, WMAA,ZAA)
         if (ps_number.eq.1) then
            Ncall = two**( N_points(0) +1 - N_iterations1 + iteration )
         else
            Ncall = two**( N_points(0)  - N_iterations1 + iteration )
         endif
      CASE(WPAAj,WMAAj)
c     print*,'here',ps_number,sub_number,N_iterations1,iteration,Ncall
         if ((N_iterations1-iteration).eq.0) then
            if (ps_number.eq.1) then
               if (sub_number.gt.4) then
                  Ncall = two**( N_points(0)+1)
               else
                  Ncall = two**( N_points(0))
               endif
            elseif(ps_number.lt.4) then
               if (sub_number.gt.2) then
                  Ncall = two**( N_points(0)-1)
               else
                  Ncall = two**( N_points(0)-2)
               endif
            else
               if (sub_number.gt.2) then
                  Ncall = two**( N_points(0)-2)
               else
                  Ncall = two**( N_points(0)-3)
               endif
            endif
         elseif((N_iterations1-iteration).eq.1) then
            if (ps_number.eq.1) then
               if(sub_number.gt.4) then
                  Ncall = two**( N_points(0))
               else
                  Ncall = two**( N_points(0)-1)
               endif
            elseif(ps_number.lt.4)then
               if(sub_number.gt.2) then
                  Ncall = two**( N_points(0)-2)
               else
                  Ncall = two**( N_points(0)-3)
               endif   
            else
               if(sub_number.gt.2) then
                  Ncall = two**( N_points(0)-3)
               else
                  Ncall = two**( N_points(0)-4)
               endif   
            endif
         elseif((N_iterations1-iteration).gt.1) then
            if (ps_number.eq.1) then
               if(sub_number.gt.4) then
                  Ncall = two**( N_points(0)-1)
               else
                  Ncall = two**( N_points(0)-2)
               endif   
            elseif(ps_number.lt.4)then
               if(sub_number.gt.2) then
                  Ncall = two**( N_points(0)-3)
               else
                  Ncall = two**( N_points(0)-4)
               endif
            else
               if(sub_number.gt.2) then
                  Ncall = two**( N_points(0)-4)
               else
                  Ncall = two**( N_points(0)-5)
               endif
            endif
         endif
      CASE DEFAULT
         Ncall = two**( N_points(0) - N_iterations1 + iteration )
      END SELECT

c     print*,'here2',ps_number,sub_number,N_iterations1,iteration,Ncall
      return

      end


********************************************************************************
********************************************************************************

      subroutine statistics_proc_NLO(ps_number)

      implicit none

c include global variables via include-files, e.g. "procID"
#include "VBFNLO/utilities/global.inc"
#include "VBFNLO/utilities/lha.inc"
#include "VBFNLO/utilities/tau_hel.inc"
#include "VBFNLO/utilities/process.inc"
#include "VBFNLO/utilities/scales.inc"

c     variables for the integration loops
      integer ps_number
      integer iteration, seed
      integer*8 Ncall, i, two
      parameter (two = 2)
      common/Ncall1/Ncall,iteration
      integer gnlo
      common /nlovariable/ gnlo

      iteration=1
      N_iterationsv=1

c          print*,'here',ps_number,sub_number,N_iterations1,iteration,Ncall
      Select Case(procID)
      CASE(WPZA, WMZA)
         if (ps_number.eq.1) then
            Ncall = two**(N_points(gnlo)-N_iterationsv+iteration)
         else
            Ncall = two**(N_points(gnlo)+1-N_iterationsv+iteration)
         endif
      CASE(WPAA,WMAA,ZAA,WPAAj,WMAAj)
         if (ps_number.eq.1) then
            if((sub_number.gt.4).or.(sub_number.lt.3))then
               if (sub_number.gt.4) then
                  N_points(3)=N_points(3)+1   
                  Ncall = two**(N_points(gnlo)+1-N_iterationsv+iteration)
                  N_points(3)=N_points(3)-1   
               else
                  Ncall = two**(N_points(gnlo)+1-N_iterationsv+iteration)
               endif
            else
               Ncall = two**(N_points(gnlo)-N_iterationsv+iteration)
            endif
         else if (ps_number.eq.4) then
            N_points(1)=N_points(1)-1
            if(sub_number.gt.2)then
               Ncall = two**(N_points(gnlo)-2-N_iterationsv+iteration)
            else
               Ncall = two**(N_points(gnlo)-3-N_iterationsv+iteration)
            endif
            N_points(1)=N_points(1)+1
         else
            if(sub_number.gt.2)then
               Ncall = two**(N_points(gnlo)-1-N_iterationsv+iteration)
            else
               N_points(3)=N_points(3)+1   
               Ncall = two**(N_points(gnlo)-2-N_iterationsv+iteration-1)
               N_points(3)=N_points(3)-1   
            endif
         endif
      CASE DEFAULT
         Ncall = two**N_points(gnlo-N_iterationsv+iteration)
      END SELECT

c       print*,'here1',ps_number,sub_number,N_iterations1,iteration,Ncall
      return

      end
      

********************************************************************************
********************************************************************************

      subroutine statistics_proc_Real(ps_number)

      implicit none

c include global variables via include-files, e.g. "procID"
#include "VBFNLO/utilities/global.inc"
#include "VBFNLO/utilities/lha.inc"
#include "VBFNLO/utilities/tau_hel.inc"
#include "VBFNLO/utilities/process.inc"
#include "VBFNLO/utilities/scales.inc"

      integer ps_number
      integer iteration, seed
      integer*8 Ncall, i, two
      parameter (two = 2)
      common/Ncall1/Ncall,iteration

      integer gnlo
      common /nlovariable/ gnlo

      Select Case(procID)
      CASE(WPZA, WMZA)
         if (ps_number.eq.1) then
            Ncall = two**( N_points(-1) - N_iterations2 + iteration )
         else
            Ncall = two**( N_points(-1)+1 - N_iterations2 + iteration )
         endif
      CASE(WPAA, WMAA, ZAA)
         if (ps_number.eq.1) then
            Ncall = two**( N_points(-1)+ 1 - N_iterations2 + iteration )
            Ncall = two**( N_points(-1)+1) ! - N_iterations2 + iteration )
         else
            Ncall = two**( N_points(-1) - N_iterations2 + iteration )
            Ncall = two**( N_points(-1)) ! - N_iterations2 + iteration )
         endif
      CASE(WPAAj,WMAAj)
         if(sub_number.eq.2)then
            N_points(-1)=N_points(-1)-1
         endif                
         if ((N_iterations2-iteration).eq.0) then
            if (ps_number.eq.1) then
               Ncall = two**( N_points(-1)+1)
            else if (ps_number.eq.4) then
               Ncall = two**( N_points(-1)-2)
            else
               Ncall = two**( N_points(-1))
            endif
         elseif((N_iterations2-iteration).eq.1) then
            if (ps_number.eq.1) then
               Ncall = two**( N_points(-1))
            else if (ps_number.eq.4) then
               Ncall = two**( N_points(-1)-3)
            else
               Ncall = two**( N_points(-1)-1)
            endif
         elseif((N_iterations2-iteration).gt.1) then
            if (ps_number.eq.1) then
               Ncall = two**( N_points(-1)-1)
            else if (ps_number.eq.4) then
               Ncall = two**( N_points(-1)-4)
            else
               Ncall = two**( N_points(-1)-2)
            endif
         endif
         if(sub_number.eq.2)then
            N_points(-1)=N_points(-1)+1
         endif
      CASE DEFAULT
         Ncall = two**( N_points(-1) - N_iterations2 + iteration )
      END SELECT
      
      return
      
      end



********************************************************************************
********************************************************************************

      subroutine statistics_proc_FLoops(ps_number)

      implicit none

c include global variables via include-files, e.g. "procID"
#include "VBFNLO/utilities/global.inc"
#include "VBFNLO/utilities/lha.inc"
#include "VBFNLO/utilities/tau_hel.inc"
#include "VBFNLO/utilities/process.inc"
#include "VBFNLO/utilities/scales.inc"

c     variables for the integration loops
      integer iteration, seed
      integer*8 Ncall, i, two
      integer ps_number
      parameter (two = 2)
      common/Ncall1/Ncall,iteration

      Select Case(procID)
      CASE(WW,WPhadWMlep,WPlepWMhad,AA)
         Ncall = two**( N_points(0) -6 - N_iterations1 + iteration )
      CASE(ZZ,ZZhad,ZA)
         Ncall = two**( N_points(0) -7 - N_iterations1 + iteration )
      CASE DEFAULT
         Ncall = two**( N_points(0) - N_iterations1 + iteration )
      END SELECT
      return

      end

